blob: c8376efd17db8a7d9d58bfe8c4d5108b34c52465 [file] [log] [blame]
Scott Anderson1a5fc952012-03-07 17:15:06 -08001function hmm() {
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07002cat <<EOF
Jeff Gastonc6dfc4e2017-05-30 17:12:37 -07003
4Run "m help" for help with the build system itself.
5
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08006Invoke ". build/envsetup.sh" from your shell to add the following functions to your environment:
Steven Moreland62054a42018-12-06 10:11:40 -08007- lunch: lunch <product_name>-<build_variant>
8 Selects <product_name> as the product to build, and <build_variant> as the variant to
9 build, and stores those selections in the environment to be read by subsequent
10 invocations of 'm' etc.
Elliott Hughesf71c05a2020-03-06 16:46:59 -080011- tapas: tapas [<App1> <App2> ...] [arm|x86|arm64|x86_64] [eng|userdebug|user]
Martin Stjernholmf692c752021-04-12 00:01:10 +010012 Sets up the build environment for building unbundled apps (APKs).
13- banchan: banchan <module1> [<module2> ...] [arm|x86|arm64|x86_64] [eng|userdebug|user]
14 Sets up the build environment for building unbundled modules (APEXes).
Anton Hanssonece9c482019-02-04 18:15:39 +000015- croot: Changes directory to the top of the tree, or a subdirectory thereof.
Steven Moreland62054a42018-12-06 10:11:40 -080016- m: Makes from the top of the tree.
Dan Willemsen67074fe2019-10-30 12:35:34 -070017- mm: Builds and installs all of the modules in the current directory, and their
18 dependencies.
19- mmm: Builds and installs all of the modules in the supplied directories, and their
20 dependencies.
Steven Moreland62054a42018-12-06 10:11:40 -080021 To limit the modules being built use the syntax: mmm dir/:target1,target2.
Dan Willemsen67074fe2019-10-30 12:35:34 -070022- mma: Same as 'mm'
23- mmma: Same as 'mmm'
Steven Moreland62054a42018-12-06 10:11:40 -080024- provision: Flash device with all required partitions. Options will be passed on to fastboot.
25- cgrep: Greps on all local C/C++ files.
26- ggrep: Greps on all local Gradle files.
Orion Hodson831472d2019-10-25 11:35:15 +010027- gogrep: Greps on all local Go files.
Steven Moreland62054a42018-12-06 10:11:40 -080028- jgrep: Greps on all local Java files.
Taesu Leeea0cecd2020-10-28 11:05:18 +090029- ktgrep: Greps on all local Kotlin files.
Steven Moreland62054a42018-12-06 10:11:40 -080030- resgrep: Greps on all local res/*.xml files.
31- mangrep: Greps on all local AndroidManifest.xml files.
Jaewoong Jung892d0fe2019-05-04 10:06:28 -070032- mgrep: Greps on all local Makefiles and *.bp files.
Jeff Sharkeyf17cddf2019-08-21 12:51:26 -060033- owngrep: Greps on all local OWNERS files.
Alistair Delva176e5342021-02-22 13:31:26 -080034- rsgrep: Greps on all local Rust files.
Steven Moreland62054a42018-12-06 10:11:40 -080035- sepgrep: Greps on all local sepolicy files.
36- sgrep: Greps on all local source files.
37- godir: Go to the directory containing a file.
38- allmod: List all modules.
39- gomod: Go to the directory containing a module.
Rett Berg78d1c932019-01-24 14:34:23 -080040- pathmod: Get the directory containing a module.
Cole Faust24c36db2021-01-23 02:39:37 +000041- outmod: Gets the location of a module's installed outputs with a certain extension.
Joe Onorato2c1aa472021-02-25 16:42:39 -080042- dirmods: Gets the modules defined in a given directory.
Cole Faust24c36db2021-01-23 02:39:37 +000043- installmod: Adb installs a module's built APK.
44- refreshmod: Refresh list of modules for allmod/gomod/pathmod/outmod/installmod.
Steven Moreland74114f12020-09-10 01:23:32 +000045- syswrite: Remount partitions (e.g. system.img) as writable, rebooting if necessary.
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -070046
Michael Bestasb744e742016-08-26 00:37:02 +030047EOF
48
49 __print_lineage_functions_help
Alexander Martinz148bcce2022-04-07 18:02:53 +020050 __print_shift_functions_help
Michael Bestasb744e742016-08-26 00:37:02 +030051
52cat <<EOF
53
Roland Levillain39341922015-10-20 12:48:19 +010054Environment options:
Steven Moreland115d1f52019-09-26 16:30:28 -070055- SANITIZE_HOST: Set to 'address' to use ASAN for all host modules.
Sasha Smundak9f27cc02019-01-31 13:25:31 -080056- ANDROID_QUIET_BUILD: set to 'true' to display only the essential messages.
Dan Albert4ae5d4b2014-10-31 16:23:08 -070057
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -070058Look at the source to view more functions. The complete list is:
59EOF
Christopher Ferris55257d22017-03-23 11:08:58 -070060 local T=$(gettop)
61 local A=""
62 local i
Alexander Martinz148bcce2022-04-07 18:02:53 +020063 for i in `cat $T/build/envsetup.sh $T/vendor/lineage/build/envsetup.sh $T/vendor/shiftos/build/envsetup.sh | sed -n "/^[[:blank:]]*function /s/function \([a-z_]*\).*/\1/p" | sort | uniq`; do
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -070064 A="$A $i"
65 done
66 echo $A
67}
68
Ying Wang08800fd2016-03-03 20:57:21 -080069# Get all the build variables needed by this script in a single call to the build system.
Matt Alexanderd9c56562020-05-21 10:49:17 +000070function build_build_var_cache()
71{
Christopher Ferris55257d22017-03-23 11:08:58 -070072 local T=$(gettop)
Ying Wang08800fd2016-03-03 20:57:21 -080073 # Grep out the variable names from the script.
Alexander Martinz148bcce2022-04-07 18:02:53 +020074 cached_vars=(`cat $T/build/envsetup.sh $T/vendor/lineage/build/envsetup.sh $T/vendor/shiftos/build/envsetup.sh | tr '()' ' ' | awk '{for(i=1;i<=NF;i++) if($i~/get_build_var/) print $(i+1)}' | sort -u | tr '\n' ' '`)
75 cached_abs_vars=(`cat $T/build/envsetup.sh $T/vendor/lineage/build/envsetup.sh $T/vendor/shiftos/build/envsetup.sh | tr '()' ' ' | awk '{for(i=1;i<=NF;i++) if($i~/get_abs_build_var/) print $(i+1)}' | sort -u | tr '\n' ' '`)
Ying Wang08800fd2016-03-03 20:57:21 -080076 # Call the build system to dump the "<val>=<value>" pairs as a shell script.
Steven Moreland05402962018-01-05 12:13:11 -080077 build_dicts_script=`\builtin cd $T; build/soong/soong_ui.bash --dumpvars-mode \
Jim Tanga881a252018-06-19 16:34:41 +080078 --vars="${cached_vars[*]}" \
79 --abs-vars="${cached_abs_vars[*]}" \
Dan Willemsenaf88c412017-07-14 11:29:44 -070080 --var-prefix=var_cache_ \
81 --abs-var-prefix=abs_var_cache_`
Ying Wang08800fd2016-03-03 20:57:21 -080082 local ret=$?
Matt Alexanderd9c56562020-05-21 10:49:17 +000083 if [ $ret -ne 0 ]
84 then
Ying Wang08800fd2016-03-03 20:57:21 -080085 unset build_dicts_script
86 return $ret
87 fi
Dan Willemsenaf88c412017-07-14 11:29:44 -070088 # Execute the script to store the "<val>=<value>" pairs as shell variables.
Ying Wang08800fd2016-03-03 20:57:21 -080089 eval "$build_dicts_script"
Ying Wang08800fd2016-03-03 20:57:21 -080090 ret=$?
Ying Wangf0cb3972016-03-04 13:56:23 -080091 unset build_dicts_script
Matt Alexanderd9c56562020-05-21 10:49:17 +000092 if [ $ret -ne 0 ]
93 then
Ying Wang08800fd2016-03-03 20:57:21 -080094 return $ret
95 fi
96 BUILD_VAR_CACHE_READY="true"
97}
98
Ying Wangf0cb3972016-03-04 13:56:23 -080099# Delete the build var cache, so that we can still call into the build system
Ying Wang08800fd2016-03-03 20:57:21 -0800100# to get build variables not listed in this script.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000101function destroy_build_var_cache()
102{
Ying Wang08800fd2016-03-03 20:57:21 -0800103 unset BUILD_VAR_CACHE_READY
Christopher Ferris55257d22017-03-23 11:08:58 -0700104 local v
Ying Wang08800fd2016-03-03 20:57:21 -0800105 for v in $cached_vars; do
106 unset var_cache_$v
107 done
108 unset cached_vars
109 for v in $cached_abs_vars; do
110 unset abs_var_cache_$v
111 done
112 unset cached_abs_vars
113}
114
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700115# Get the value of a build variable as an absolute path.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000116function get_abs_build_var()
117{
118 if [ "$BUILD_VAR_CACHE_READY" = "true" ]
119 then
Vishwath Mohan7d35f002016-03-11 10:00:40 -0800120 eval "echo \"\${abs_var_cache_$1}\""
Timi0469c3f2021-04-15 16:41:18 +0200121 return
Ying Wang08800fd2016-03-03 20:57:21 -0800122 fi
123
Christopher Ferris55257d22017-03-23 11:08:58 -0700124 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700125 if [ ! "$T" ]; then
126 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
127 return
128 fi
Dan Willemsenaf88c412017-07-14 11:29:44 -0700129 (\cd $T; build/soong/soong_ui.bash --dumpvar-mode --abs $1)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700130}
131
132# Get the exact value of a build variable.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000133function get_build_var()
134{
135 if [ "$BUILD_VAR_CACHE_READY" = "true" ]
136 then
Vishwath Mohan7d35f002016-03-11 10:00:40 -0800137 eval "echo \"\${var_cache_$1}\""
Roland Levillain23c46cf2020-03-31 16:11:05 +0100138 return 0
Ying Wang08800fd2016-03-03 20:57:21 -0800139 fi
140
Christopher Ferris55257d22017-03-23 11:08:58 -0700141 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700142 if [ ! "$T" ]; then
143 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
Roland Levillain23c46cf2020-03-31 16:11:05 +0100144 return 1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700145 fi
Dan Willemsenaf88c412017-07-14 11:29:44 -0700146 (\cd $T; build/soong/soong_ui.bash --dumpvar-mode $1)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800147}
148
149# check to see if the supplied product is one we can build
Matt Alexanderd9c56562020-05-21 10:49:17 +0000150function check_product()
151{
Christopher Ferris55257d22017-03-23 11:08:58 -0700152 local T=$(gettop)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800153 if [ ! "$T" ]; then
154 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
155 return
156 fi
Luca Stefani93102ff2017-08-17 21:21:23 +0200157 if (echo -n $1 | grep -q -e "^lineage_") ; then
158 LINEAGE_BUILD=$(echo -n $1 | sed -e 's/^lineage_//g')
159 else
Alexander Martinz729d5182022-04-07 19:26:37 +0200160 LINEAGE_BUILD=$1
Luca Stefani93102ff2017-08-17 21:21:23 +0200161 fi
162 export LINEAGE_BUILD
163
Jeff Browne33ba4c2011-07-11 22:11:46 -0700164 TARGET_PRODUCT=$1 \
165 TARGET_BUILD_VARIANT= \
166 TARGET_BUILD_TYPE= \
Joe Onoratoda12daf2010-06-09 18:18:31 -0700167 TARGET_BUILD_APPS= \
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800168 get_build_var TARGET_DEVICE > /dev/null
169 # hide successful answers, but allow the errors to show
170}
171
172VARIANT_CHOICES=(user userdebug eng)
173
174# check to see if the supplied variant is valid
Matt Alexanderd9c56562020-05-21 10:49:17 +0000175function check_variant()
176{
Christopher Ferris55257d22017-03-23 11:08:58 -0700177 local v
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800178 for v in ${VARIANT_CHOICES[@]}
179 do
Matt Alexanderd9c56562020-05-21 10:49:17 +0000180 if [ "$v" = "$1" ]
181 then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800182 return 0
183 fi
184 done
185 return 1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700186}
187
Matt Alexanderd9c56562020-05-21 10:49:17 +0000188function setpaths()
189{
Christopher Ferris55257d22017-03-23 11:08:58 -0700190 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700191 if [ ! "$T" ]; then
192 echo "Couldn't locate the top of the tree. Try setting TOP."
193 return
194 fi
195
196 ##################################################################
197 # #
198 # Read me before you modify this code #
199 # #
200 # This function sets ANDROID_BUILD_PATHS to what it is adding #
201 # to PATH, and the next time it is run, it removes that from #
202 # PATH. This is required so lunch can be run more than once #
203 # and still have working paths. #
204 # #
205 ##################################################################
206
Raphael Mollc639c782011-06-20 17:25:01 -0700207 # Note: on windows/cygwin, ANDROID_BUILD_PATHS will contain spaces
208 # due to "C:\Program Files" being in the path.
209
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700210 # out with the old
Matt Alexanderd9c56562020-05-21 10:49:17 +0000211 if [ -n "$ANDROID_BUILD_PATHS" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700212 export PATH=${PATH/$ANDROID_BUILD_PATHS/}
213 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +0000214 if [ -n "$ANDROID_PRE_BUILD_PATHS" ] ; then
Doug Zongker29034982011-04-22 08:16:56 -0700215 export PATH=${PATH/$ANDROID_PRE_BUILD_PATHS/}
Ying Wangaa1c9b52012-11-26 20:51:59 -0800216 # strip leading ':', if any
217 export PATH=${PATH/:%/}
Jeff Hamilton4a1c70e2010-06-21 18:26:38 -0500218 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700219
220 # and in with the new
Christopher Ferris55257d22017-03-23 11:08:58 -0700221 local prebuiltdir=$(getprebuilt)
222 local gccprebuiltdir=$(get_abs_build_var ANDROID_GCC_PREBUILTS)
Raphael732936d2011-06-22 14:35:32 -0700223
Ben Cheng8bc4c432012-11-16 13:29:13 -0800224 # defined in core/config.mk
Christopher Ferris55257d22017-03-23 11:08:58 -0700225 local targetgccversion=$(get_build_var TARGET_GCC_VERSION)
226 local targetgccversion2=$(get_build_var 2ND_TARGET_GCC_VERSION)
Ben Cheng15266702012-12-10 16:04:39 -0800227 export TARGET_GCC_VERSION=$targetgccversion
Ben Cheng8bc4c432012-11-16 13:29:13 -0800228
Raphael Mollc639c782011-06-20 17:25:01 -0700229 # The gcc toolchain does not exists for windows/cygwin. In this case, do not reference it.
Ben Chengfba67bf2014-02-25 10:27:07 -0800230 export ANDROID_TOOLCHAIN=
231 export ANDROID_TOOLCHAIN_2ND_ARCH=
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200232 local ARCH=$(get_build_var TARGET_ARCH)
Christopher Ferris55257d22017-03-23 11:08:58 -0700233 local toolchaindir toolchaindir2=
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200234 case $ARCH in
Matt Alexanderd9c56562020-05-21 10:49:17 +0000235 x86) toolchaindir=x86/x86_64-linux-android-$targetgccversion/bin
Mark D Horn7d0ede72012-03-14 14:20:30 -0700236 ;;
Matt Alexanderd9c56562020-05-21 10:49:17 +0000237 x86_64) toolchaindir=x86/x86_64-linux-android-$targetgccversion/bin
Pavel Chupinfd82a492012-11-26 09:50:07 +0400238 ;;
Matt Alexanderd9c56562020-05-21 10:49:17 +0000239 arm) toolchaindir=arm/arm-linux-androideabi-$targetgccversion/bin
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200240 ;;
Matt Alexanderd9c56562020-05-21 10:49:17 +0000241 arm64) toolchaindir=aarch64/aarch64-linux-android-$targetgccversion/bin;
242 toolchaindir2=arm/arm-linux-androideabi-$targetgccversion2/bin
Ben Chengdb4fc202013-10-04 16:02:59 -0700243 ;;
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200244 *)
245 echo "Can't find toolchain for unknown architecture: $ARCH"
246 toolchaindir=xxxxxxxxx
Mark D Horn7d0ede72012-03-14 14:20:30 -0700247 ;;
248 esac
Jing Yuf5172c72012-03-29 20:45:50 -0700249 if [ -d "$gccprebuiltdir/$toolchaindir" ]; then
Ben Chengfba67bf2014-02-25 10:27:07 -0800250 export ANDROID_TOOLCHAIN=$gccprebuiltdir/$toolchaindir
Raphael Mollc639c782011-06-20 17:25:01 -0700251 fi
Raphael732936d2011-06-22 14:35:32 -0700252
Christopher Ferris55257d22017-03-23 11:08:58 -0700253 if [ "$toolchaindir2" -a -d "$gccprebuiltdir/$toolchaindir2" ]; then
Ben Chengfba67bf2014-02-25 10:27:07 -0800254 export ANDROID_TOOLCHAIN_2ND_ARCH=$gccprebuiltdir/$toolchaindir2
255 fi
256
Dan Willemsen838dcec2021-09-30 22:40:34 +0000257 export ANDROID_DEV_SCRIPTS=$T/development/scripts:$T/prebuilts/devtools/tools
Yueyao Zhuefc786a2017-04-07 14:11:54 -0700258
259 # add kernel specific binaries
260 case $(uname -s) in
261 Linux)
262 export ANDROID_DEV_SCRIPTS=$ANDROID_DEV_SCRIPTS:$T/prebuilts/misc/linux-x86/dtc:$T/prebuilts/misc/linux-x86/libufdt
263 ;;
264 *)
265 ;;
266 esac
267
Torne (Richard Coles)0091bae2017-10-03 16:31:18 -0400268 ANDROID_BUILD_PATHS=$(get_build_var ANDROID_BUILD_PATHS):$ANDROID_TOOLCHAIN
Martin Stjernholm6a012262021-11-24 14:56:15 +0000269 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_TOOLCHAIN_2ND_ARCH
Yi Kongdfd00b12019-05-21 16:00:04 -0700270 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_DEV_SCRIPTS
271
272 # Append llvm binutils prebuilts path to ANDROID_BUILD_PATHS.
273 local ANDROID_LLVM_BINUTILS=$(get_abs_build_var ANDROID_CLANG_PREBUILTS)/llvm-binutils-stable
274 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_LLVM_BINUTILS
David 'Digit' Turner94d16e52014-05-05 16:13:50 +0200275
Stephen Hinesaa8d72c2020-02-04 09:15:18 -0800276 # Set up ASAN_SYMBOLIZER_PATH for SANITIZE_HOST=address builds.
277 export ASAN_SYMBOLIZER_PATH=$ANDROID_LLVM_BINUTILS/llvm-symbolizer
278
David 'Digit' Turner94d16e52014-05-05 16:13:50 +0200279 # If prebuilts/android-emulator/<system>/ exists, prepend it to our PATH
280 # to ensure that the corresponding 'emulator' binaries are used.
281 case $(uname -s) in
282 Darwin)
283 ANDROID_EMULATOR_PREBUILTS=$T/prebuilts/android-emulator/darwin-x86_64
284 ;;
285 Linux)
286 ANDROID_EMULATOR_PREBUILTS=$T/prebuilts/android-emulator/linux-x86_64
287 ;;
288 *)
289 ANDROID_EMULATOR_PREBUILTS=
290 ;;
291 esac
292 if [ -n "$ANDROID_EMULATOR_PREBUILTS" -a -d "$ANDROID_EMULATOR_PREBUILTS" ]; then
Yi Kongdfd00b12019-05-21 16:00:04 -0700293 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_EMULATOR_PREBUILTS
David 'Digit' Turner94d16e52014-05-05 16:13:50 +0200294 export ANDROID_EMULATOR_PREBUILTS
295 fi
296
Jim Tangb3fda302018-12-22 10:24:55 +0800297 # Append asuite prebuilts path to ANDROID_BUILD_PATHS.
298 local os_arch=$(get_build_var HOST_PREBUILT_TAG)
Ryan Prichard8426a192019-07-15 18:05:29 -0700299 local ACLOUD_PATH="$T/prebuilts/asuite/acloud/$os_arch"
300 local AIDEGEN_PATH="$T/prebuilts/asuite/aidegen/$os_arch"
301 local ATEST_PATH="$T/prebuilts/asuite/atest/$os_arch"
Martin Stjernholm6a012262021-11-24 14:56:15 +0000302 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ACLOUD_PATH:$AIDEGEN_PATH:$ATEST_PATH
Jim Tangb3fda302018-12-22 10:24:55 +0800303
Martin Stjernholm6a012262021-11-24 14:56:15 +0000304 export ANDROID_BUILD_PATHS=$(tr -s : <<<"${ANDROID_BUILD_PATHS}:")
Ryan Prichard8426a192019-07-15 18:05:29 -0700305 export PATH=$ANDROID_BUILD_PATHS$PATH
Jim Tang22f4c322018-12-17 15:21:53 +0800306
307 # out with the duplicate old
308 if [ -n $ANDROID_PYTHONPATH ]; then
309 export PYTHONPATH=${PYTHONPATH//$ANDROID_PYTHONPATH/}
310 fi
311 # and in with the new
312 export ANDROID_PYTHONPATH=$T/development/python-packages:
Jim Tangc4dba1d2019-07-25 16:54:27 +0800313 if [ -n $VENDOR_PYTHONPATH ]; then
314 ANDROID_PYTHONPATH=$ANDROID_PYTHONPATH$VENDOR_PYTHONPATH
315 fi
Jim Tang22f4c322018-12-17 15:21:53 +0800316 export PYTHONPATH=$ANDROID_PYTHONPATH$PYTHONPATH
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800317
Colin Crosse97e6932017-06-30 16:01:45 -0700318 export ANDROID_JAVA_HOME=$(get_abs_build_var ANDROID_JAVA_HOME)
319 export JAVA_HOME=$ANDROID_JAVA_HOME
320 export ANDROID_JAVA_TOOLCHAIN=$(get_abs_build_var ANDROID_JAVA_TOOLCHAIN)
321 export ANDROID_PRE_BUILD_PATHS=$ANDROID_JAVA_TOOLCHAIN:
322 export PATH=$ANDROID_PRE_BUILD_PATHS$PATH
Jeff Hamilton4a1c70e2010-06-21 18:26:38 -0500323
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800324 unset ANDROID_PRODUCT_OUT
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700325 export ANDROID_PRODUCT_OUT=$(get_abs_build_var PRODUCT_OUT)
326 export OUT=$ANDROID_PRODUCT_OUT
327
Jeff Brown8fd5cce2011-03-24 17:03:06 -0700328 unset ANDROID_HOST_OUT
329 export ANDROID_HOST_OUT=$(get_abs_build_var HOST_OUT)
330
Jiyong Parkc02b1c42020-11-03 11:06:39 +0900331 unset ANDROID_SOONG_HOST_OUT
332 export ANDROID_SOONG_HOST_OUT=$(get_abs_build_var SOONG_HOST_OUT)
333
Simran Basidd050ed2017-02-13 13:46:48 -0800334 unset ANDROID_HOST_OUT_TESTCASES
335 export ANDROID_HOST_OUT_TESTCASES=$(get_abs_build_var HOST_OUT_TESTCASES)
336
337 unset ANDROID_TARGET_OUT_TESTCASES
338 export ANDROID_TARGET_OUT_TESTCASES=$(get_abs_build_var TARGET_OUT_TESTCASES)
339
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800340 # needed for building linux on MacOS
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700341 # TODO: fix the path
342 #export HOST_EXTRACFLAGS="-I "$T/system/kernel_headers/host_include
343}
344
Rupert Shuttleworth5d60d022020-10-25 05:20:03 +0000345function bazel()
Rupert Shuttleworth131fa7d2020-10-12 13:41:12 +0000346{
Jingwen Chen17d56992021-06-10 08:17:54 +0000347 if which bazel &>/dev/null; then
348 >&2 echo "NOTE: bazel() function sourced from Android's envsetup.sh is being used instead of $(which bazel)"
349 >&2 echo
Rupert Shuttleworth131fa7d2020-10-12 13:41:12 +0000350 fi
351
Jingwen Chen17d56992021-06-10 08:17:54 +0000352 local T="$(gettop)"
353 if [ ! "$T" ]; then
354 >&2 echo "Couldn't locate the top of the Android tree. Try setting TOP. This bazel() function cannot be used outside of the AOSP directory."
355 return
Rupert Shuttleworth131fa7d2020-10-12 13:41:12 +0000356 fi
357
Rupert Shuttleworth5d60d022020-10-25 05:20:03 +0000358 "$T/tools/bazel" "$@"
Rupert Shuttleworth131fa7d2020-10-12 13:41:12 +0000359}
360
Matt Alexanderd9c56562020-05-21 10:49:17 +0000361function printconfig()
362{
Christopher Ferris55257d22017-03-23 11:08:58 -0700363 local T=$(gettop)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800364 if [ ! "$T" ]; then
365 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
366 return
367 fi
368 get_build_var report_config
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700369}
370
Matt Alexanderd9c56562020-05-21 10:49:17 +0000371function set_stuff_for_environment()
372{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800373 setpaths
374 set_sequence_number
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700375
Ben Chengaac3f812013-08-13 14:38:15 -0700376 # With this environment variable new GCC can apply colors to warnings/errors
377 export GCC_COLORS='error=01;31:warning=01;35:note=01;36:caret=01;32:locus=01:quote=01'
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700378}
379
Matt Alexanderd9c56562020-05-21 10:49:17 +0000380function set_sequence_number()
381{
Colin Cross88737132017-03-21 17:41:03 -0700382 export BUILD_ENV_SEQUENCE_NUMBER=13
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700383}
384
Makoto Onukida971062018-06-18 10:15:19 -0700385# Takes a command name, and check if it's in ENVSETUP_NO_COMPLETION or not.
386function should_add_completion() {
Jim Tanga881a252018-06-19 16:34:41 +0800387 local cmd="$(basename $1| sed 's/_completion//' |sed 's/\.\(.*\)*sh$//')"
Makoto Onukida971062018-06-18 10:15:19 -0700388 case :"$ENVSETUP_NO_COMPLETION": in
Jim Tanga881a252018-06-19 16:34:41 +0800389 *:"$cmd":*)
390 return 1
391 ;;
Makoto Onukida971062018-06-18 10:15:19 -0700392 esac
393 return 0
394}
395
Matt Alexanderd9c56562020-05-21 10:49:17 +0000396function addcompletions()
397{
Ben Taitelbaum8c2c9cf2020-09-22 16:45:05 -0700398 local f=
Kenny Root52aa81c2011-07-15 11:07:06 -0700399
Jim Tanga881a252018-06-19 16:34:41 +0800400 # Keep us from trying to run in something that's neither bash nor zsh.
401 if [ -z "$BASH_VERSION" -a -z "$ZSH_VERSION" ]; then
Kenny Root52aa81c2011-07-15 11:07:06 -0700402 return
403 fi
404
405 # Keep us from trying to run in bash that's too old.
Jim Tanga881a252018-06-19 16:34:41 +0800406 if [ -n "$BASH_VERSION" -a ${BASH_VERSINFO[0]} -lt 3 ]; then
Kenny Root52aa81c2011-07-15 11:07:06 -0700407 return
408 fi
409
Jim Tanga881a252018-06-19 16:34:41 +0800410 local completion_files=(
411 system/core/adb/adb.bash
412 system/core/fastboot/fastboot.bash
Jim Tangb3fda302018-12-22 10:24:55 +0800413 tools/asuite/asuite.sh
Jim Tanga881a252018-06-19 16:34:41 +0800414 )
Makoto Onukida971062018-06-18 10:15:19 -0700415 # Completion can be disabled selectively to allow users to use non-standard completion.
416 # e.g.
417 # ENVSETUP_NO_COMPLETION=adb # -> disable adb completion
418 # ENVSETUP_NO_COMPLETION=adb:bit # -> disable adb and bit completion
Jim Tanga881a252018-06-19 16:34:41 +0800419 for f in ${completion_files[*]}; do
420 if [ -f "$f" ] && should_add_completion "$f"; then
Kenny Root52aa81c2011-07-15 11:07:06 -0700421 . $f
Elliott Hughesce18dd42018-04-03 13:49:48 -0700422 fi
423 done
Joe Onorato002a6c72016-10-20 16:39:49 -0700424
Matt Alexanderd9c56562020-05-21 10:49:17 +0000425 if should_add_completion bit ; then
Makoto Onukida971062018-06-18 10:15:19 -0700426 complete -C "bit --tab" bit
427 fi
Anton Hanssonece9c482019-02-04 18:15:39 +0000428 if [ -z "$ZSH_VERSION" ]; then
429 # Doesn't work in zsh.
430 complete -o nospace -F _croot croot
431 fi
Jim Tanga881a252018-06-19 16:34:41 +0800432 complete -F _lunch lunch
Steven Moreland62054a42018-12-06 10:11:40 -0800433
Cole Faust24c36db2021-01-23 02:39:37 +0000434 complete -F _complete_android_module_names pathmod
dimitry73b84812018-12-11 18:06:00 +0100435 complete -F _complete_android_module_names gomod
Cole Faust24c36db2021-01-23 02:39:37 +0000436 complete -F _complete_android_module_names outmod
437 complete -F _complete_android_module_names installmod
dimitry73b84812018-12-11 18:06:00 +0100438 complete -F _complete_android_module_names m
Kenny Root52aa81c2011-07-15 11:07:06 -0700439}
440
Joe Onorato824608c2022-04-08 11:06:16 -0700441function multitree_lunch_help()
442{
443 echo "usage: lunch PRODUCT-VARIANT" 1>&2
444 echo " Set up android build environment based on a product short name and variant" 1>&2
445 echo 1>&2
446 echo "lunch COMBO_FILE VARIANT" 1>&2
447 echo " Set up android build environment based on a specific lunch combo file" 1>&2
448 echo " and variant." 1>&2
449 echo 1>&2
450 echo "lunch --print [CONFIG]" 1>&2
451 echo " Print the contents of a configuration. If CONFIG is supplied, that config" 1>&2
452 echo " will be flattened and printed. If CONFIG is not supplied, the currently" 1>&2
453 echo " selected config will be printed. Returns 0 on success or nonzero on error." 1>&2
454 echo 1>&2
455 echo "lunch --list" 1>&2
456 echo " List all possible combo files available in the current tree" 1>&2
457 echo 1>&2
458 echo "lunch --help" 1>&2
459 echo "lunch -h" 1>&2
460 echo " Prints this message." 1>&2
461}
462
463function multitree_lunch()
464{
465 local code
466 local results
467 if $(echo "$1" | grep -q '^-') ; then
468 # Calls starting with a -- argument are passed directly and the function
469 # returns with the lunch.py exit code.
470 build/make/orchestrator/core/lunch.py "$@"
471 code=$?
472 if [[ $code -eq 2 ]] ; then
473 echo 1>&2
474 multitree_lunch_help
475 return $code
476 elif [[ $code -ne 0 ]] ; then
477 return $code
478 fi
479 else
480 # All other calls go through the --lunch variant of lunch.py
481 results=($(build/make/orchestrator/core/lunch.py --lunch "$@"))
482 code=$?
483 if [[ $code -eq 2 ]] ; then
484 echo 1>&2
485 multitree_lunch_help
486 return $code
487 elif [[ $code -ne 0 ]] ; then
488 return $code
489 fi
490
491 export TARGET_BUILD_COMBO=${results[0]}
492 export TARGET_BUILD_VARIANT=${results[1]}
493 fi
494}
495
Matt Alexanderd9c56562020-05-21 10:49:17 +0000496function choosetype()
497{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700498 echo "Build type choices are:"
499 echo " 1. release"
500 echo " 2. debug"
501 echo
502
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800503 local DEFAULT_NUM DEFAULT_VALUE
Jeff Browne33ba4c2011-07-11 22:11:46 -0700504 DEFAULT_NUM=1
505 DEFAULT_VALUE=release
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700506
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800507 export TARGET_BUILD_TYPE=
508 local ANSWER
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700509 while [ -z $TARGET_BUILD_TYPE ]
510 do
511 echo -n "Which would you like? ["$DEFAULT_NUM"] "
Matt Alexanderd9c56562020-05-21 10:49:17 +0000512 if [ -z "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800513 read ANSWER
514 else
515 echo $1
516 ANSWER=$1
517 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700518 case $ANSWER in
519 "")
520 export TARGET_BUILD_TYPE=$DEFAULT_VALUE
521 ;;
522 1)
523 export TARGET_BUILD_TYPE=release
524 ;;
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800525 release)
526 export TARGET_BUILD_TYPE=release
527 ;;
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700528 2)
529 export TARGET_BUILD_TYPE=debug
530 ;;
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800531 debug)
532 export TARGET_BUILD_TYPE=debug
533 ;;
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700534 *)
535 echo
536 echo "I didn't understand your response. Please try again."
537 echo
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700538 ;;
539 esac
Matt Alexanderd9c56562020-05-21 10:49:17 +0000540 if [ -n "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800541 break
542 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700543 done
544
Ying Wang08800fd2016-03-03 20:57:21 -0800545 build_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700546 set_stuff_for_environment
Ying Wang08800fd2016-03-03 20:57:21 -0800547 destroy_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700548}
549
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800550#
551# This function isn't really right: It chooses a TARGET_PRODUCT
552# based on the list of boards. Usually, that gets you something
553# that kinda works with a generic product, but really, you should
554# pick a product by name.
555#
Matt Alexanderd9c56562020-05-21 10:49:17 +0000556function chooseproduct()
557{
Christopher Ferris55257d22017-03-23 11:08:58 -0700558 local default_value
Matt Alexanderd9c56562020-05-21 10:49:17 +0000559 if [ "x$TARGET_PRODUCT" != x ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700560 default_value=$TARGET_PRODUCT
561 else
Ying Wang0a76df52015-06-08 11:57:26 -0700562 default_value=aosp_arm
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700563 fi
564
Ying Wang08800fd2016-03-03 20:57:21 -0800565 export TARGET_BUILD_APPS=
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800566 export TARGET_PRODUCT=
567 local ANSWER
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700568 while [ -z "$TARGET_PRODUCT" ]
569 do
Joe Onorato8849aed2009-04-29 15:56:47 -0700570 echo -n "Which product would you like? [$default_value] "
Matt Alexanderd9c56562020-05-21 10:49:17 +0000571 if [ -z "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800572 read ANSWER
573 else
574 echo $1
575 ANSWER=$1
576 fi
577
Matt Alexanderd9c56562020-05-21 10:49:17 +0000578 if [ -z "$ANSWER" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700579 export TARGET_PRODUCT=$default_value
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800580 else
Matt Alexanderd9c56562020-05-21 10:49:17 +0000581 if check_product $ANSWER
582 then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800583 export TARGET_PRODUCT=$ANSWER
584 else
585 echo "** Not a valid product: $ANSWER"
586 fi
587 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +0000588 if [ -n "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800589 break
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700590 fi
591 done
592
Ying Wang08800fd2016-03-03 20:57:21 -0800593 build_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700594 set_stuff_for_environment
Ying Wang08800fd2016-03-03 20:57:21 -0800595 destroy_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700596}
597
Matt Alexanderd9c56562020-05-21 10:49:17 +0000598function choosevariant()
599{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800600 echo "Variant choices are:"
601 local index=1
602 local v
603 for v in ${VARIANT_CHOICES[@]}
604 do
605 # The product name is the name of the directory containing
606 # the makefile we found, above.
607 echo " $index. $v"
608 index=$(($index+1))
609 done
610
611 local default_value=eng
612 local ANSWER
613
614 export TARGET_BUILD_VARIANT=
615 while [ -z "$TARGET_BUILD_VARIANT" ]
616 do
617 echo -n "Which would you like? [$default_value] "
Matt Alexanderd9c56562020-05-21 10:49:17 +0000618 if [ -z "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800619 read ANSWER
620 else
621 echo $1
622 ANSWER=$1
623 fi
624
Matt Alexanderd9c56562020-05-21 10:49:17 +0000625 if [ -z "$ANSWER" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800626 export TARGET_BUILD_VARIANT=$default_value
Matt Alexanderd9c56562020-05-21 10:49:17 +0000627 elif (echo -n $ANSWER | grep -q -e "^[0-9][0-9]*$") ; then
628 if [ "$ANSWER" -le "${#VARIANT_CHOICES[@]}" ] ; then
Guillaume Chelfice000fd2019-10-03 12:02:46 +0200629 export TARGET_BUILD_VARIANT=${VARIANT_CHOICES[@]:$(($ANSWER-1)):1}
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800630 fi
631 else
Matt Alexanderd9c56562020-05-21 10:49:17 +0000632 if check_variant $ANSWER
633 then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800634 export TARGET_BUILD_VARIANT=$ANSWER
635 else
636 echo "** Not a valid variant: $ANSWER"
637 fi
638 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +0000639 if [ -n "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800640 break
641 fi
642 done
643}
644
Matt Alexanderd9c56562020-05-21 10:49:17 +0000645function choosecombo()
646{
Jeff Browne33ba4c2011-07-11 22:11:46 -0700647 choosetype $1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700648
649 echo
650 echo
Jeff Browne33ba4c2011-07-11 22:11:46 -0700651 chooseproduct $2
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700652
653 echo
654 echo
Jeff Browne33ba4c2011-07-11 22:11:46 -0700655 choosevariant $3
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800656
657 echo
Ying Wang08800fd2016-03-03 20:57:21 -0800658 build_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700659 set_stuff_for_environment
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800660 printconfig
Ying Wang08800fd2016-03-03 20:57:21 -0800661 destroy_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700662}
663
Matt Alexanderd9c56562020-05-21 10:49:17 +0000664function add_lunch_combo()
665{
Dan Willemsen5436c7e2019-02-11 21:31:47 -0800666 if [ -n "$ZSH_VERSION" ]; then
667 echo -n "${funcfiletrace[1]}: "
668 else
669 echo -n "${BASH_SOURCE[1]}:${BASH_LINENO[0]}: "
670 fi
671 echo "add_lunch_combo is obsolete. Use COMMON_LUNCH_CHOICES in your AndroidProducts.mk instead."
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800672}
673
Matt Alexanderd9c56562020-05-21 10:49:17 +0000674function print_lunch_menu()
675{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700676 local uname=$(uname)
Roland Levillain23c46cf2020-03-31 16:11:05 +0100677 local choices
Colin Crossfa50d402021-04-22 13:05:41 -0700678 choices=$(TARGET_BUILD_APPS= TARGET_PRODUCT= TARGET_BUILD_VARIANT= get_build_var COMMON_LUNCH_CHOICES 2>/dev/null)
Roland Levillain23c46cf2020-03-31 16:11:05 +0100679 local ret=$?
680
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700681 echo
682 echo "You're building on" $uname
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700683 echo
Roland Levillain23c46cf2020-03-31 16:11:05 +0100684
Matt Alexanderd9c56562020-05-21 10:49:17 +0000685 if [ $ret -ne 0 ]
686 then
Roland Levillain23c46cf2020-03-31 16:11:05 +0100687 echo "Warning: Cannot display lunch menu."
688 echo
689 echo "Note: You can invoke lunch with an explicit target:"
690 echo
691 echo " usage: lunch [target]" >&2
692 echo
693 return
694 fi
695
Will Burr40401202022-02-07 12:12:01 +0000696 echo "Lunch menu .. Here are the common combinations:"
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800697
698 local i=1
699 local choice
Dan Willemsen91763e92019-10-03 15:13:12 -0700700 for choice in $(echo $choices)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800701 do
702 echo " $i. $choice"
703 i=$(($i+1))
704 done
705
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700706 echo
707}
708
Matt Alexanderd9c56562020-05-21 10:49:17 +0000709function lunch()
710{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800711 local answer
712
Steven Moreland92793dc2020-02-25 18:30:18 -0800713 if [[ $# -gt 1 ]]; then
714 echo "usage: lunch [target]" >&2
715 return 1
716 fi
717
Will Burr40401202022-02-07 12:12:01 +0000718 local used_lunch_menu=0
719
Steven Moreland92793dc2020-02-25 18:30:18 -0800720 if [ "$1" ]; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800721 answer=$1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700722 else
723 print_lunch_menu
Will Burr40401202022-02-07 12:12:01 +0000724 echo "Which would you like? [aosp_arm-eng]"
725 echo -n "Pick from common choices above (e.g. 13) or specify your own (e.g. aosp_barbet-eng): "
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800726 read answer
Will Burr40401202022-02-07 12:12:01 +0000727 used_lunch_menu=1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700728 fi
729
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800730 local selection=
731
Matt Alexanderd9c56562020-05-21 10:49:17 +0000732 if [ -z "$answer" ]
733 then
Jean-Baptiste Queru324c1232013-03-22 15:53:54 -0700734 selection=aosp_arm-eng
Matt Alexanderd9c56562020-05-21 10:49:17 +0000735 elif (echo -n $answer | grep -q -e "^[0-9][0-9]*$")
736 then
Dan Willemsen5436c7e2019-02-11 21:31:47 -0800737 local choices=($(TARGET_BUILD_APPS= get_build_var COMMON_LUNCH_CHOICES))
Matt Alexanderd9c56562020-05-21 10:49:17 +0000738 if [ $answer -le ${#choices[@]} ]
739 then
Jim Tang0e3397b2018-10-03 18:25:50 +0800740 # array in zsh starts from 1 instead of 0.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000741 if [ -n "$ZSH_VERSION" ]
742 then
Jim Tang0e3397b2018-10-03 18:25:50 +0800743 selection=${choices[$(($answer))]}
744 else
745 selection=${choices[$(($answer-1))]}
746 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800747 fi
Colin Cross88737132017-03-21 17:41:03 -0700748 else
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800749 selection=$answer
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700750 fi
751
Joe Onoratoda12daf2010-06-09 18:18:31 -0700752 export TARGET_BUILD_APPS=
753
Colin Cross88737132017-03-21 17:41:03 -0700754 local product variant_and_version variant version
Colin Cross88737132017-03-21 17:41:03 -0700755 product=${selection%%-*} # Trim everything after first dash
756 variant_and_version=${selection#*-} # Trim everything up to first dash
757 if [ "$variant_and_version" != "$selection" ]; then
758 variant=${variant_and_version%%-*}
759 if [ "$variant" != "$variant_and_version" ]; then
760 version=${variant_and_version#*-}
761 fi
Jeff Browne33ba4c2011-07-11 22:11:46 -0700762 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800763
Matt Alexanderd9c56562020-05-21 10:49:17 +0000764 if [ -z "$product" ]
765 then
Ying Wang08800fd2016-03-03 20:57:21 -0800766 echo
Colin Cross88737132017-03-21 17:41:03 -0700767 echo "Invalid lunch combo: $selection"
Jeff Browne33ba4c2011-07-11 22:11:46 -0700768 return 1
769 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800770
Alexander Martinz5b3b55b2022-12-21 21:10:51 +0100771 check_product $product
Luca Stefani93102ff2017-08-17 21:21:23 +0200772
Colin Cross88737132017-03-21 17:41:03 -0700773 TARGET_PRODUCT=$product \
774 TARGET_BUILD_VARIANT=$variant \
775 TARGET_PLATFORM_VERSION=$version \
776 build_build_var_cache
Matt Alexanderd9c56562020-05-21 10:49:17 +0000777 if [ $? -ne 0 ]
778 then
Anton Hansson32fa7ee2021-06-14 17:09:58 +0100779 if [[ "$product" =~ .*_(eng|user|userdebug) ]]
780 then
781 echo "Did you mean -${product/*_/}? (dash instead of underscore)"
782 fi
Colin Cross88737132017-03-21 17:41:03 -0700783 return 1
784 fi
Colin Cross88737132017-03-21 17:41:03 -0700785 export TARGET_PRODUCT=$(get_build_var TARGET_PRODUCT)
786 export TARGET_BUILD_VARIANT=$(get_build_var TARGET_BUILD_VARIANT)
Colin Crossb105e362017-05-01 14:21:28 -0700787 if [ -n "$version" ]; then
788 export TARGET_PLATFORM_VERSION=$(get_build_var TARGET_PLATFORM_VERSION)
789 else
790 unset TARGET_PLATFORM_VERSION
791 fi
Jeff Browne33ba4c2011-07-11 22:11:46 -0700792 export TARGET_BUILD_TYPE=release
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700793
Will Burr40401202022-02-07 12:12:01 +0000794 if [ $used_lunch_menu -eq 1 ]; then
795 echo
796 echo "Hint: next time you can simply run 'lunch $selection'"
797 fi
798
Sasha Smundak90d07bc2020-06-04 10:48:15 -0700799 [[ -n "${ANDROID_QUIET_BUILD:-}" ]] || echo
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800800
Luca Stefani93102ff2017-08-17 21:21:23 +0200801 fixup_common_out_dir
802
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700803 set_stuff_for_environment
Sasha Smundak90d07bc2020-06-04 10:48:15 -0700804 [[ -n "${ANDROID_QUIET_BUILD:-}" ]] || printconfig
Ying Wang08800fd2016-03-03 20:57:21 -0800805 destroy_build_var_cache
Kousik Kumar41dacd12021-05-11 18:38:38 -0400806
807 if [[ -n "${CHECK_MU_CONFIG:-}" ]]; then
808 check_mu_config
809 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700810}
811
Dan Willemsenaf2e1f82018-04-04 15:41:41 -0700812unset COMMON_LUNCH_CHOICES_CACHE
Jeff Davidson513d7a42010-08-02 10:00:44 -0700813# Tab completion for lunch.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000814function _lunch()
815{
Jeff Davidson513d7a42010-08-02 10:00:44 -0700816 local cur prev opts
817 COMPREPLY=()
818 cur="${COMP_WORDS[COMP_CWORD]}"
819 prev="${COMP_WORDS[COMP_CWORD-1]}"
820
Dan Willemsenaf2e1f82018-04-04 15:41:41 -0700821 if [ -z "$COMMON_LUNCH_CHOICES_CACHE" ]; then
Dan Willemsen5436c7e2019-02-11 21:31:47 -0800822 COMMON_LUNCH_CHOICES_CACHE=$(TARGET_BUILD_APPS= get_build_var COMMON_LUNCH_CHOICES)
Dan Willemsenaf2e1f82018-04-04 15:41:41 -0700823 fi
824
825 COMPREPLY=( $(compgen -W "${COMMON_LUNCH_CHOICES_CACHE}" -- ${cur}) )
Jeff Davidson513d7a42010-08-02 10:00:44 -0700826 return 0
827}
Jeff Davidson513d7a42010-08-02 10:00:44 -0700828
Joe Onoratoda12daf2010-06-09 18:18:31 -0700829# Configures the build to build unbundled apps.
Doug Zongker0d8179e2014-04-16 11:34:34 -0700830# Run tapas with one or more app names (from LOCAL_PACKAGE_NAME)
Matt Alexanderd9c56562020-05-21 10:49:17 +0000831function tapas()
832{
Jeff Gaston9fb05d82017-08-21 18:27:00 -0700833 local showHelp="$(echo $* | xargs -n 1 echo | \grep -E '^(help)$' | xargs)"
Elliott Hughesf71c05a2020-03-06 16:46:59 -0800834 local arch="$(echo $* | xargs -n 1 echo | \grep -E '^(arm|x86|arm64|x86_64)$' | xargs)"
Doug Zongker0d8179e2014-04-16 11:34:34 -0700835 local variant="$(echo $* | xargs -n 1 echo | \grep -E '^(user|userdebug|eng)$' | xargs)"
Jeff Hamilton5069bd62014-09-04 21:28:00 -0700836 local density="$(echo $* | xargs -n 1 echo | \grep -E '^(ldpi|mdpi|tvdpi|hdpi|xhdpi|xxhdpi|xxxhdpi|alldpi)$' | xargs)"
Colin Cross7f49a672022-01-27 18:15:53 -0800837 local keys="$(echo $* | xargs -n 1 echo | \grep -E '^(devkeys)$' | xargs)"
838 local apps="$(echo $* | xargs -n 1 echo | \grep -E -v '^(user|userdebug|eng|arm|x86|arm64|x86_64|ldpi|mdpi|tvdpi|hdpi|xhdpi|xxhdpi|xxxhdpi|alldpi|devkeys)$' | xargs)"
839
Joe Onoratoda12daf2010-06-09 18:18:31 -0700840
Jeff Gaston9fb05d82017-08-21 18:27:00 -0700841 if [ "$showHelp" != "" ]; then
842 $(gettop)/build/make/tapasHelp.sh
843 return
844 fi
845
Ying Wang67f02922012-08-22 10:25:20 -0700846 if [ $(echo $arch | wc -w) -gt 1 ]; then
847 echo "tapas: Error: Multiple build archs supplied: $arch"
848 return
849 fi
Joe Onoratoda12daf2010-06-09 18:18:31 -0700850 if [ $(echo $variant | wc -w) -gt 1 ]; then
851 echo "tapas: Error: Multiple build variants supplied: $variant"
852 return
853 fi
Jeff Hamilton5069bd62014-09-04 21:28:00 -0700854 if [ $(echo $density | wc -w) -gt 1 ]; then
855 echo "tapas: Error: Multiple densities supplied: $density"
856 return
857 fi
Colin Cross7f49a672022-01-27 18:15:53 -0800858 if [ $(echo $keys | wc -w) -gt 1 ]; then
859 echo "tapas: Error: Multiple keys supplied: $keys"
860 return
861 fi
Ying Wang67f02922012-08-22 10:25:20 -0700862
Ying Wang0a76df52015-06-08 11:57:26 -0700863 local product=aosp_arm
Ying Wang67f02922012-08-22 10:25:20 -0700864 case $arch in
Matt Alexanderd9c56562020-05-21 10:49:17 +0000865 x86) product=aosp_x86;;
866 arm64) product=aosp_arm64;;
867 x86_64) product=aosp_x86_64;;
Ying Wang67f02922012-08-22 10:25:20 -0700868 esac
Colin Cross7f49a672022-01-27 18:15:53 -0800869 if [ -n "$keys" ]; then
870 product=${product/aosp_/aosp_${keys}_}
871 fi;
872
Joe Onoratoda12daf2010-06-09 18:18:31 -0700873 if [ -z "$variant" ]; then
874 variant=eng
875 fi
Ying Wangc048c9b2010-06-24 15:08:33 -0700876 if [ -z "$apps" ]; then
877 apps=all
878 fi
Justin Morey29d225c2014-11-04 13:35:51 -0600879 if [ -z "$density" ]; then
880 density=alldpi
881 fi
Joe Onoratoda12daf2010-06-09 18:18:31 -0700882
Ying Wang67f02922012-08-22 10:25:20 -0700883 export TARGET_PRODUCT=$product
Joe Onoratoda12daf2010-06-09 18:18:31 -0700884 export TARGET_BUILD_VARIANT=$variant
Jeff Hamilton5069bd62014-09-04 21:28:00 -0700885 export TARGET_BUILD_DENSITY=$density
Joe Onoratoda12daf2010-06-09 18:18:31 -0700886 export TARGET_BUILD_TYPE=release
887 export TARGET_BUILD_APPS=$apps
888
Ying Wang08800fd2016-03-03 20:57:21 -0800889 build_build_var_cache
Joe Onoratoda12daf2010-06-09 18:18:31 -0700890 set_stuff_for_environment
891 printconfig
Ying Wang08800fd2016-03-03 20:57:21 -0800892 destroy_build_var_cache
Joe Onoratoda12daf2010-06-09 18:18:31 -0700893}
894
Martin Stjernholmf692c752021-04-12 00:01:10 +0100895# Configures the build to build unbundled Android modules (APEXes).
896# Run banchan with one or more module names (from apex{} modules).
897function banchan()
898{
899 local showHelp="$(echo $* | xargs -n 1 echo | \grep -E '^(help)$' | xargs)"
Martin Stjernholm2b8d9232021-04-16 20:45:03 +0100900 local product="$(echo $* | xargs -n 1 echo | \grep -E '^(.*_)?(arm|x86|arm64|x86_64)$' | xargs)"
Martin Stjernholmf692c752021-04-12 00:01:10 +0100901 local variant="$(echo $* | xargs -n 1 echo | \grep -E '^(user|userdebug|eng)$' | xargs)"
Martin Stjernholm2b8d9232021-04-16 20:45:03 +0100902 local apps="$(echo $* | xargs -n 1 echo | \grep -E -v '^(user|userdebug|eng|(.*_)?(arm|x86|arm64|x86_64))$' | xargs)"
Martin Stjernholmf692c752021-04-12 00:01:10 +0100903
904 if [ "$showHelp" != "" ]; then
905 $(gettop)/build/make/banchanHelp.sh
906 return
907 fi
908
Martin Stjernholm2b8d9232021-04-16 20:45:03 +0100909 if [ -z "$product" ]; then
910 product=arm
911 elif [ $(echo $product | wc -w) -gt 1 ]; then
912 echo "banchan: Error: Multiple build archs or products supplied: $products"
Martin Stjernholmf692c752021-04-12 00:01:10 +0100913 return
914 fi
915 if [ $(echo $variant | wc -w) -gt 1 ]; then
916 echo "banchan: Error: Multiple build variants supplied: $variant"
917 return
918 fi
919 if [ -z "$apps" ]; then
920 echo "banchan: Error: No modules supplied"
921 return
922 fi
923
Martin Stjernholm2b8d9232021-04-16 20:45:03 +0100924 case $product in
925 arm) product=module_arm;;
Martin Stjernholmf692c752021-04-12 00:01:10 +0100926 x86) product=module_x86;;
927 arm64) product=module_arm64;;
928 x86_64) product=module_x86_64;;
929 esac
930 if [ -z "$variant" ]; then
931 variant=eng
932 fi
933
934 export TARGET_PRODUCT=$product
935 export TARGET_BUILD_VARIANT=$variant
936 export TARGET_BUILD_DENSITY=alldpi
937 export TARGET_BUILD_TYPE=release
938
939 # This setup currently uses TARGET_BUILD_APPS just like tapas, but the use
940 # case is different and it may diverge in the future.
941 export TARGET_BUILD_APPS=$apps
942
943 build_build_var_cache
944 set_stuff_for_environment
945 printconfig
946 destroy_build_var_cache
947}
948
Matt Alexanderd9c56562020-05-21 10:49:17 +0000949function gettop
950{
Colin Cross6cdc5d22017-10-20 11:37:33 -0700951 local TOPFILE=build/make/core/envsetup.mk
Matt Alexanderd9c56562020-05-21 10:49:17 +0000952 if [ -n "$TOP" -a -f "$TOP/$TOPFILE" ] ; then
Brian Carlstroma5c4f172014-09-12 00:33:25 -0700953 # The following circumlocution ensures we remove symlinks from TOP.
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000954 (cd "$TOP"; PWD= /bin/pwd)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700955 else
Matt Alexanderd9c56562020-05-21 10:49:17 +0000956 if [ -f $TOPFILE ] ; then
Dan Bornsteind0b274d2009-11-24 15:48:50 -0800957 # The following circumlocution (repeated below as well) ensures
958 # that we record the true directory name and not one that is
959 # faked up with symlink names.
960 PWD= /bin/pwd
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700961 else
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800962 local HERE=$PWD
Christopher Ferris55257d22017-03-23 11:08:58 -0700963 local T=
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000964 while [ \( ! \( -f $TOPFILE \) \) -a \( "$PWD" != "/" \) ]; do
Ying Wang9cd17642012-12-13 10:52:07 -0800965 \cd ..
synergyb112a402013-07-05 19:47:47 -0700966 T=`PWD= /bin/pwd -P`
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700967 done
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000968 \cd "$HERE"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700969 if [ -f "$T/$TOPFILE" ]; then
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000970 echo "$T"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700971 fi
972 fi
973 fi
974}
975
Matt Alexanderd9c56562020-05-21 10:49:17 +0000976function croot()
977{
Christopher Ferris55257d22017-03-23 11:08:58 -0700978 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700979 if [ "$T" ]; then
Marie Janssen32ec50a2016-04-21 16:53:39 -0700980 if [ "$1" ]; then
981 \cd $(gettop)/$1
982 else
983 \cd $(gettop)
984 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700985 else
986 echo "Couldn't locate the top of the tree. Try setting TOP."
987 fi
988}
989
Matt Alexanderd9c56562020-05-21 10:49:17 +0000990function _croot()
991{
Anton Hanssonece9c482019-02-04 18:15:39 +0000992 local T=$(gettop)
993 if [ "$T" ]; then
994 local cur="${COMP_WORDS[COMP_CWORD]}"
995 k=0
996 for c in $(compgen -d ${T}/${cur}); do
997 COMPREPLY[k++]=${c#${T}/}/
998 done
999 fi
1000}
1001
Matt Alexanderd9c56562020-05-21 10:49:17 +00001002function cproj()
1003{
Colin Cross6cdc5d22017-10-20 11:37:33 -07001004 local TOPFILE=build/make/core/envsetup.mk
Joe Onorato2a5d4d82009-07-30 10:23:21 -07001005 local HERE=$PWD
Christopher Ferris55257d22017-03-23 11:08:58 -07001006 local T=
Joe Onorato2a5d4d82009-07-30 10:23:21 -07001007 while [ \( ! \( -f $TOPFILE \) \) -a \( $PWD != "/" \) ]; do
1008 T=$PWD
1009 if [ -f "$T/Android.mk" ]; then
Ying Wang9cd17642012-12-13 10:52:07 -08001010 \cd $T
Joe Onorato2a5d4d82009-07-30 10:23:21 -07001011 return
1012 fi
Ying Wang9cd17642012-12-13 10:52:07 -08001013 \cd ..
Joe Onorato2a5d4d82009-07-30 10:23:21 -07001014 done
Ying Wang9cd17642012-12-13 10:52:07 -08001015 \cd $HERE
Joe Onorato2a5d4d82009-07-30 10:23:21 -07001016 echo "can't find Android.mk"
1017}
1018
Daniel Sandler47e0a882013-07-30 13:23:52 -04001019# simplified version of ps; output in the form
1020# <pid> <procname>
1021function qpid() {
1022 local prepend=''
1023 local append=''
Matt Alexanderd9c56562020-05-21 10:49:17 +00001024 if [ "$1" = "--exact" ]; then
Daniel Sandler47e0a882013-07-30 13:23:52 -04001025 prepend=' '
1026 append='$'
1027 shift
Matt Alexanderd9c56562020-05-21 10:49:17 +00001028 elif [ "$1" = "--help" -o "$1" = "-h" ]; then
Ying Wang08800fd2016-03-03 20:57:21 -08001029 echo "usage: qpid [[--exact] <process name|pid>"
1030 return 255
1031 fi
Daniel Sandler47e0a882013-07-30 13:23:52 -04001032
1033 local EXE="$1"
Matt Alexanderd9c56562020-05-21 10:49:17 +00001034 if [ "$EXE" ] ; then
Ying Wang08800fd2016-03-03 20:57:21 -08001035 qpid | \grep "$prepend$EXE$append"
1036 else
1037 adb shell ps \
1038 | tr -d '\r' \
1039 | sed -e 1d -e 's/^[^ ]* *\([0-9]*\).* \([^ ]*\)$/\1 \2/'
1040 fi
Daniel Sandler47e0a882013-07-30 13:23:52 -04001041}
1042
Steven Moreland74114f12020-09-10 01:23:32 +00001043# syswrite - disable verity, reboot if needed, and remount image
1044#
1045# Easy way to make system.img/etc writable
1046function syswrite() {
1047 adb wait-for-device && adb root || return 1
1048 if [[ $(adb disable-verity | grep "reboot") ]]; then
1049 echo "rebooting"
1050 adb reboot && adb wait-for-device && adb root || return 1
1051 fi
1052 adb wait-for-device && adb remount || return 1
1053}
1054
Iliyan Malcheve675cfb2014-11-03 17:04:47 -08001055# coredump_setup - enable core dumps globally for any process
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001056# that has the core-file-size limit set correctly
1057#
Iliyan Malchevaf5de972014-11-04 20:57:37 -08001058# NOTE: You must call also coredump_enable for a specific process
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001059# if its core-file-size limit is not set already.
1060# NOTE: Core dumps are written to ramdisk; they will not survive a reboot!
1061
Matt Alexanderd9c56562020-05-21 10:49:17 +00001062function coredump_setup()
1063{
1064 echo "Getting root...";
1065 adb root;
1066 adb wait-for-device;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001067
Matt Alexanderd9c56562020-05-21 10:49:17 +00001068 echo "Remounting root partition read-write...";
1069 adb shell mount -w -o remount -t rootfs rootfs;
1070 sleep 1;
1071 adb wait-for-device;
1072 adb shell mkdir -p /cores;
1073 adb shell mount -t tmpfs tmpfs /cores;
1074 adb shell chmod 0777 /cores;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001075
Matt Alexanderd9c56562020-05-21 10:49:17 +00001076 echo "Granting SELinux permission to dump in /cores...";
1077 adb shell restorecon -R /cores;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001078
Matt Alexanderd9c56562020-05-21 10:49:17 +00001079 echo "Set core pattern.";
1080 adb shell 'echo /cores/core.%p > /proc/sys/kernel/core_pattern';
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001081
Ying Wang08800fd2016-03-03 20:57:21 -08001082 echo "Done."
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001083}
1084
Iliyan Malchevaf5de972014-11-04 20:57:37 -08001085# coredump_enable - enable core dumps for the specified process
Matt Alexanderd9c56562020-05-21 10:49:17 +00001086# $1 = PID of process (e.g., $(pid mediaserver))
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001087#
Iliyan Malchevaf5de972014-11-04 20:57:37 -08001088# NOTE: coredump_setup must have been called as well for a core
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001089# dump to actually be generated.
1090
Matt Alexanderd9c56562020-05-21 10:49:17 +00001091function coredump_enable()
1092{
1093 local PID=$1;
Ying Wang08800fd2016-03-03 20:57:21 -08001094 if [ -z "$PID" ]; then
Matt Alexanderd9c56562020-05-21 10:49:17 +00001095 printf "Expecting a PID!\n";
1096 return;
1097 fi;
1098 echo "Setting core limit for $PID to infinite...";
Elliott Hughes910a3552016-03-07 13:53:53 -08001099 adb shell /system/bin/ulimit -p $PID -c unlimited
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001100}
1101
1102# core - send SIGV and pull the core for process
Matt Alexanderd9c56562020-05-21 10:49:17 +00001103# $1 = PID of process (e.g., $(pid mediaserver))
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001104#
Iliyan Malchevaf5de972014-11-04 20:57:37 -08001105# NOTE: coredump_setup must be called once per boot for core dumps to be
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001106# enabled globally.
1107
Matt Alexanderd9c56562020-05-21 10:49:17 +00001108function core()
1109{
1110 local PID=$1;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001111
Ying Wang08800fd2016-03-03 20:57:21 -08001112 if [ -z "$PID" ]; then
Matt Alexanderd9c56562020-05-21 10:49:17 +00001113 printf "Expecting a PID!\n";
1114 return;
1115 fi;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001116
Matt Alexanderd9c56562020-05-21 10:49:17 +00001117 local CORENAME=core.$PID;
1118 local COREPATH=/cores/$CORENAME;
1119 local SIG=SEGV;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001120
Matt Alexanderd9c56562020-05-21 10:49:17 +00001121 coredump_enable $1;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001122
Matt Alexanderd9c56562020-05-21 10:49:17 +00001123 local done=0;
Ying Wang08800fd2016-03-03 20:57:21 -08001124 while [ $(adb shell "[ -d /proc/$PID ] && echo -n yes") ]; do
Matt Alexanderd9c56562020-05-21 10:49:17 +00001125 printf "\tSending SIG%s to %d...\n" $SIG $PID;
1126 adb shell kill -$SIG $PID;
1127 sleep 1;
1128 done;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001129
Matt Alexanderd9c56562020-05-21 10:49:17 +00001130 adb shell "while [ ! -f $COREPATH ] ; do echo waiting for $COREPATH to be generated; sleep 1; done"
1131 echo "Done: core is under $COREPATH on device.";
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001132}
1133
Christopher Tate744ee802009-11-12 15:33:08 -08001134# systemstack - dump the current stack trace of all threads in the system process
1135# to the usual ANR traces file
Matt Alexanderd9c56562020-05-21 10:49:17 +00001136function systemstack()
1137{
Jeff Sharkeyf5824372013-02-19 17:00:46 -08001138 stacks system_server
1139}
1140
Michael Wrightaeed7212014-06-19 19:58:12 -07001141# Read the ELF header from /proc/$PID/exe to determine if the process is
1142# 64-bit.
Matt Alexanderd9c56562020-05-21 10:49:17 +00001143function is64bit()
1144{
Ben Chengfba67bf2014-02-25 10:27:07 -08001145 local PID="$1"
Matt Alexanderd9c56562020-05-21 10:49:17 +00001146 if [ "$PID" ] ; then
1147 if [[ "$(adb shell cat /proc/$PID/exe | xxd -l 1 -s 4 -p)" -eq "02" ]] ; then
Ben Chengfba67bf2014-02-25 10:27:07 -08001148 echo "64"
1149 else
1150 echo ""
1151 fi
1152 else
1153 echo ""
1154 fi
1155}
1156
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001157case `uname -s` in
1158 Darwin)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001159 function sgrep()
1160 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001161 find -E . -name .repo -prune -o -name .git -prune -o -type f -iregex '.*\.(c|h|cc|cpp|hpp|S|java|kt|xml|sh|mk|aidl|vts|proto)' \
Mike Frysinger5e479732015-09-22 18:13:48 -04001162 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001163 }
Matt Alexanderd9c56562020-05-21 10:49:17 +00001164
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001165 ;;
1166 *)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001167 function sgrep()
1168 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001169 find . -name .repo -prune -o -name .git -prune -o -type f -iregex '.*\.\(c\|h\|cc\|cpp\|hpp\|S\|java\|kt\|xml\|sh\|mk\|aidl\|vts\|proto\)' \
Mike Frysinger5e479732015-09-22 18:13:48 -04001170 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001171 }
1172 ;;
1173esac
1174
Matt Alexanderd9c56562020-05-21 10:49:17 +00001175function gettargetarch
1176{
Raghu Gandham8da43102012-07-25 19:57:22 -07001177 get_build_var TARGET_ARCH
1178}
1179
Matt Alexanderd9c56562020-05-21 10:49:17 +00001180function ggrep()
1181{
Mike Frysinger5e479732015-09-22 18:13:48 -04001182 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.gradle" \
1183 -exec grep --color -n "$@" {} +
Jon Boekenoogencbca56f2014-04-07 10:57:38 -07001184}
1185
Matt Alexanderd9c56562020-05-21 10:49:17 +00001186function gogrep()
1187{
Orion Hodson831472d2019-10-25 11:35:15 +01001188 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.go" \
1189 -exec grep --color -n "$@" {} +
1190}
1191
Matt Alexanderd9c56562020-05-21 10:49:17 +00001192function jgrep()
1193{
Mike Frysinger5e479732015-09-22 18:13:48 -04001194 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.java" \
1195 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001196}
1197
Alistair Delva176e5342021-02-22 13:31:26 -08001198function rsgrep()
Jeff Vander Stoep1431ab82021-02-02 19:18:26 +01001199{
1200 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.rs" \
1201 -exec grep --color -n "$@" {} +
1202}
1203
Taesu Leeea0cecd2020-10-28 11:05:18 +09001204function ktgrep()
1205{
1206 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.kt" \
1207 -exec grep --color -n "$@" {} +
1208}
1209
Matt Alexanderd9c56562020-05-21 10:49:17 +00001210function cgrep()
1211{
Mike Frysinger5e479732015-09-22 18:13:48 -04001212 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f \( -name '*.c' -o -name '*.cc' -o -name '*.cpp' -o -name '*.h' -o -name '*.hpp' \) \
1213 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001214}
1215
Matt Alexanderd9c56562020-05-21 10:49:17 +00001216function resgrep()
1217{
Christopher Ferris55257d22017-03-23 11:08:58 -07001218 local dir
Mike Frysinger5e479732015-09-22 18:13:48 -04001219 for dir in `find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -name res -type d`; do
1220 find $dir -type f -name '*\.xml' -exec grep --color -n "$@" {} +
1221 done
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001222}
1223
Matt Alexanderd9c56562020-05-21 10:49:17 +00001224function mangrep()
1225{
Mike Frysinger5e479732015-09-22 18:13:48 -04001226 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o -type f -name 'AndroidManifest.xml' \
1227 -exec grep --color -n "$@" {} +
Jeff Sharkey50b61e92013-03-08 10:20:47 -08001228}
1229
Matt Alexanderd9c56562020-05-21 10:49:17 +00001230function owngrep()
1231{
Jeff Sharkeyf17cddf2019-08-21 12:51:26 -06001232 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o -type f -name 'OWNERS' \
1233 -exec grep --color -n "$@" {} +
1234}
1235
Matt Alexanderd9c56562020-05-21 10:49:17 +00001236function sepgrep()
1237{
Mike Frysinger5e479732015-09-22 18:13:48 -04001238 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o -name sepolicy -type d \
1239 -exec grep --color -n -r --exclude-dir=\.git "$@" {} +
Alex Klyubinba5fc8e2013-05-06 14:11:48 -07001240}
1241
Matt Alexanderd9c56562020-05-21 10:49:17 +00001242function rcgrep()
1243{
Mike Frysinger5e479732015-09-22 18:13:48 -04001244 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.rc*" \
1245 -exec grep --color -n "$@" {} +
Jeff Sharkeyea0068a2015-02-26 14:13:46 -08001246}
1247
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001248case `uname -s` in
1249 Darwin)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001250 function mgrep()
1251 {
Orion Hodson831472d2019-10-25 11:35:15 +01001252 find -E . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o \( -iregex '.*/(Makefile|Makefile\..*|.*\.make|.*\.mak|.*\.mk|.*\.bp)' -o -regex '(.*/)?(build|soong)/.*[^/]*\.go' \) -type f \
Mike Frysinger5e479732015-09-22 18:13:48 -04001253 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001254 }
1255
Matt Alexanderd9c56562020-05-21 10:49:17 +00001256 function treegrep()
1257 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001258 find -E . -name .repo -prune -o -name .git -prune -o -type f -iregex '.*\.(c|h|cpp|hpp|S|java|kt|xml)' \
Mike Frysinger5e479732015-09-22 18:13:48 -04001259 -exec grep --color -n -i "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001260 }
1261
1262 ;;
1263 *)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001264 function mgrep()
1265 {
Orion Hodson831472d2019-10-25 11:35:15 +01001266 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o \( -regextype posix-egrep -iregex '(.*\/Makefile|.*\/Makefile\..*|.*\.make|.*\.mak|.*\.mk|.*\.bp)' -o -regextype posix-extended -regex '(.*/)?(build|soong)/.*[^/]*\.go' \) -type f \
Mike Frysinger5e479732015-09-22 18:13:48 -04001267 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001268 }
1269
Matt Alexanderd9c56562020-05-21 10:49:17 +00001270 function treegrep()
1271 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001272 find . -name .repo -prune -o -name .git -prune -o -regextype posix-egrep -iregex '.*\.(c|h|cpp|hpp|S|java|kt|xml)' -type f \
Mike Frysinger5e479732015-09-22 18:13:48 -04001273 -exec grep --color -n -i "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001274 }
1275
1276 ;;
1277esac
1278
Matt Alexanderd9c56562020-05-21 10:49:17 +00001279function getprebuilt
1280{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001281 get_abs_build_var ANDROID_PREBUILTS
1282}
1283
Matt Alexanderd9c56562020-05-21 10:49:17 +00001284function tracedmdump()
1285{
Christopher Ferris55257d22017-03-23 11:08:58 -07001286 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001287 if [ ! "$T" ]; then
1288 echo "Couldn't locate the top of the tree. Try setting TOP."
1289 return
1290 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001291 local prebuiltdir=$(getprebuilt)
Raghu Gandham8da43102012-07-25 19:57:22 -07001292 local arch=$(gettargetarch)
1293 local KERNEL=$T/prebuilts/qemu-kernel/$arch/vmlinux-qemu
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001294
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001295 local TRACE=$1
Matt Alexanderd9c56562020-05-21 10:49:17 +00001296 if [ ! "$TRACE" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001297 echo "usage: tracedmdump tracename"
1298 return
1299 fi
1300
Matt Alexanderd9c56562020-05-21 10:49:17 +00001301 if [ ! -r "$KERNEL" ] ; then
Jack Veenstra60116fc2009-04-09 18:12:34 -07001302 echo "Error: cannot find kernel: '$KERNEL'"
1303 return
1304 fi
1305
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001306 local BASETRACE=$(basename $TRACE)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001307 if [ "$BASETRACE" = "$TRACE" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001308 TRACE=$ANDROID_PRODUCT_OUT/traces/$TRACE
1309 fi
1310
1311 echo "post-processing traces..."
1312 rm -f $TRACE/qtrace.dexlist
1313 post_trace $TRACE
1314 if [ $? -ne 0 ]; then
1315 echo "***"
1316 echo "*** Error: malformed trace. Did you remember to exit the emulator?"
1317 echo "***"
1318 return
1319 fi
1320 echo "generating dexlist output..."
1321 /bin/ls $ANDROID_PRODUCT_OUT/system/framework/*.jar $ANDROID_PRODUCT_OUT/system/app/*.apk $ANDROID_PRODUCT_OUT/data/app/*.apk 2>/dev/null | xargs dexlist > $TRACE/qtrace.dexlist
1322 echo "generating dmtrace data..."
1323 q2dm -r $ANDROID_PRODUCT_OUT/symbols $TRACE $KERNEL $TRACE/dmtrace || return
1324 echo "generating html file..."
1325 dmtracedump -h $TRACE/dmtrace >| $TRACE/dmtrace.html || return
1326 echo "done, see $TRACE/dmtrace.html for details"
1327 echo "or run:"
1328 echo " traceview $TRACE/dmtrace"
1329}
1330
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001331# communicate with a running device or emulator, set up necessary state,
1332# and run the hat command.
Matt Alexanderd9c56562020-05-21 10:49:17 +00001333function runhat()
1334{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001335 # process standard adb options
1336 local adbTarget=""
Matt Alexanderd9c56562020-05-21 10:49:17 +00001337 if [ "$1" = "-d" -o "$1" = "-e" ]; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001338 adbTarget=$1
1339 shift 1
Matt Alexanderd9c56562020-05-21 10:49:17 +00001340 elif [ "$1" = "-s" ]; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001341 adbTarget="$1 $2"
1342 shift 2
1343 fi
1344 local adbOptions=${adbTarget}
Matt Alexanderd9c56562020-05-21 10:49:17 +00001345 #echo adbOptions = ${adbOptions}
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001346
1347 # runhat options
1348 local targetPid=$1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001349
Matt Alexanderd9c56562020-05-21 10:49:17 +00001350 if [ "$targetPid" = "" ]; then
Andy McFaddenb6289852010-07-12 08:00:19 -07001351 echo "Usage: runhat [ -d | -e | -s serial ] target-pid"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001352 return
1353 fi
1354
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001355 # confirm hat is available
1356 if [ -z $(which hat) ]; then
1357 echo "hat is not available in this configuration."
1358 return
1359 fi
1360
Andy McFaddenb6289852010-07-12 08:00:19 -07001361 # issue "am" command to cause the hprof dump
Nick Kralevich9948b1e2014-07-18 15:45:38 -07001362 local devFile=/data/local/tmp/hprof-$targetPid
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001363 echo "Poking $targetPid and waiting for data..."
Dianne Hackborn6b9549f2012-09-26 15:00:59 -07001364 echo "Storing data at $devFile"
Andy McFaddenb6289852010-07-12 08:00:19 -07001365 adb ${adbOptions} shell am dumpheap $targetPid $devFile
The Android Open Source Project88b60792009-03-03 19:28:42 -08001366 echo "Press enter when logcat shows \"hprof: heap dump completed\""
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001367 echo -n "> "
1368 read
1369
The Android Open Source Project88b60792009-03-03 19:28:42 -08001370 local localFile=/tmp/$$-hprof
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001371
The Android Open Source Project88b60792009-03-03 19:28:42 -08001372 echo "Retrieving file $devFile..."
1373 adb ${adbOptions} pull $devFile $localFile
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001374
The Android Open Source Project88b60792009-03-03 19:28:42 -08001375 adb ${adbOptions} shell rm $devFile
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001376
The Android Open Source Project88b60792009-03-03 19:28:42 -08001377 echo "Running hat on $localFile"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001378 echo "View the output by pointing your browser at http://localhost:7000/"
1379 echo ""
Dianne Hackborn6e4e1bb2011-11-10 15:19:51 -08001380 hat -JXmx512m $localFile
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001381}
1382
Matt Alexanderd9c56562020-05-21 10:49:17 +00001383function getbugreports()
1384{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001385 local reports=(`adb shell ls /sdcard/bugreports | tr -d '\r'`)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001386
1387 if [ ! "$reports" ]; then
1388 echo "Could not locate any bugreports."
1389 return
1390 fi
1391
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001392 local report
1393 for report in ${reports[@]}
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001394 do
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001395 echo "/sdcard/bugreports/${report}"
1396 adb pull /sdcard/bugreports/${report} ${report}
1397 gunzip ${report}
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001398 done
1399}
1400
Matt Alexanderd9c56562020-05-21 10:49:17 +00001401function getsdcardpath()
1402{
Victoria Lease1b296b42012-08-21 15:44:06 -07001403 adb ${adbOptions} shell echo -n \$\{EXTERNAL_STORAGE\}
1404}
1405
Matt Alexanderd9c56562020-05-21 10:49:17 +00001406function getscreenshotpath()
1407{
Victoria Lease1b296b42012-08-21 15:44:06 -07001408 echo "$(getsdcardpath)/Pictures/Screenshots"
1409}
1410
Matt Alexanderd9c56562020-05-21 10:49:17 +00001411function getlastscreenshot()
1412{
Victoria Lease1b296b42012-08-21 15:44:06 -07001413 local screenshot_path=$(getscreenshotpath)
1414 local screenshot=`adb ${adbOptions} ls ${screenshot_path} | grep Screenshot_[0-9-]*.*\.png | sort -rk 3 | cut -d " " -f 4 | head -n 1`
Matt Alexanderd9c56562020-05-21 10:49:17 +00001415 if [ "$screenshot" = "" ]; then
Victoria Lease1b296b42012-08-21 15:44:06 -07001416 echo "No screenshots found."
1417 return
1418 fi
1419 echo "${screenshot}"
1420 adb ${adbOptions} pull ${screenshot_path}/${screenshot}
1421}
1422
Matt Alexanderd9c56562020-05-21 10:49:17 +00001423function startviewserver()
1424{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001425 local port=4939
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001426 if [ $# -gt 0 ]; then
1427 port=$1
1428 fi
1429 adb shell service call window 1 i32 $port
1430}
1431
Matt Alexanderd9c56562020-05-21 10:49:17 +00001432function stopviewserver()
1433{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001434 adb shell service call window 2
1435}
1436
Matt Alexanderd9c56562020-05-21 10:49:17 +00001437function isviewserverstarted()
1438{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001439 adb shell service call window 3
1440}
1441
Matt Alexanderd9c56562020-05-21 10:49:17 +00001442function key_home()
1443{
Romain Guyb84049a2010-10-04 16:56:11 -07001444 adb shell input keyevent 3
1445}
1446
Matt Alexanderd9c56562020-05-21 10:49:17 +00001447function key_back()
1448{
Romain Guyb84049a2010-10-04 16:56:11 -07001449 adb shell input keyevent 4
1450}
1451
Matt Alexanderd9c56562020-05-21 10:49:17 +00001452function key_menu()
1453{
Romain Guyb84049a2010-10-04 16:56:11 -07001454 adb shell input keyevent 82
1455}
1456
Matt Alexanderd9c56562020-05-21 10:49:17 +00001457function smoketest()
1458{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001459 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
1460 echo "Couldn't locate output files. Try running 'lunch' first." >&2
1461 return
1462 fi
Christopher Ferris55257d22017-03-23 11:08:58 -07001463 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001464 if [ ! "$T" ]; then
1465 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
1466 return
1467 fi
1468
Ying Wang9cd17642012-12-13 10:52:07 -08001469 (\cd "$T" && mmm tests/SmokeTest) &&
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001470 adb uninstall com.android.smoketest > /dev/null &&
1471 adb uninstall com.android.smoketest.tests > /dev/null &&
1472 adb install $ANDROID_PRODUCT_OUT/data/app/SmokeTestApp.apk &&
1473 adb install $ANDROID_PRODUCT_OUT/data/app/SmokeTest.apk &&
1474 adb shell am instrument -w com.android.smoketest.tests/android.test.InstrumentationTestRunner
1475}
1476
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001477# simple shortcut to the runtest command
Matt Alexanderd9c56562020-05-21 10:49:17 +00001478function runtest()
1479{
Christopher Ferris55257d22017-03-23 11:08:58 -07001480 local T=$(gettop)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001481 if [ ! "$T" ]; then
1482 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
1483 return
1484 fi
Brett Chabot3fb149d2009-10-21 20:05:26 -07001485 ("$T"/development/testrunner/runtest.py $@)
Brett Chabot762748c2009-03-27 10:25:11 -07001486}
1487
The Android Open Source Project88b60792009-03-03 19:28:42 -08001488function godir () {
1489 if [[ -z "$1" ]]; then
1490 echo "Usage: godir <regex>"
1491 return
1492 fi
Christopher Ferris55257d22017-03-23 11:08:58 -07001493 local T=$(gettop)
1494 local FILELIST
Matt Alexanderd9c56562020-05-21 10:49:17 +00001495 if [ ! "$OUT_DIR" = "" ]; then
Brian Carlstromf2257422015-09-30 20:28:54 -07001496 mkdir -p $OUT_DIR
1497 FILELIST=$OUT_DIR/filelist
1498 else
1499 FILELIST=$T/filelist
1500 fi
1501 if [[ ! -f $FILELIST ]]; then
The Android Open Source Project88b60792009-03-03 19:28:42 -08001502 echo -n "Creating index..."
Brian Carlstromf2257422015-09-30 20:28:54 -07001503 (\cd $T; find . -wholename ./out -prune -o -wholename ./.repo -prune -o -type f > $FILELIST)
The Android Open Source Project88b60792009-03-03 19:28:42 -08001504 echo " Done"
1505 echo ""
1506 fi
1507 local lines
Brian Carlstromf2257422015-09-30 20:28:54 -07001508 lines=($(\grep "$1" $FILELIST | sed -e 's/\/[^/]*$//' | sort | uniq))
Matt Alexanderd9c56562020-05-21 10:49:17 +00001509 if [[ ${#lines[@]} = 0 ]]; then
The Android Open Source Project88b60792009-03-03 19:28:42 -08001510 echo "Not found"
1511 return
1512 fi
1513 local pathname
1514 local choice
1515 if [[ ${#lines[@]} > 1 ]]; then
1516 while [[ -z "$pathname" ]]; do
1517 local index=1
1518 local line
1519 for line in ${lines[@]}; do
1520 printf "%6s %s\n" "[$index]" $line
Doug Zongker29034982011-04-22 08:16:56 -07001521 index=$(($index + 1))
The Android Open Source Project88b60792009-03-03 19:28:42 -08001522 done
1523 echo
1524 echo -n "Select one: "
1525 unset choice
1526 read choice
1527 if [[ $choice -gt ${#lines[@]} || $choice -lt 1 ]]; then
1528 echo "Invalid choice"
1529 continue
1530 fi
Guillaume Chelfice000fd2019-10-03 12:02:46 +02001531 pathname=${lines[@]:$(($choice-1)):1}
The Android Open Source Project88b60792009-03-03 19:28:42 -08001532 done
1533 else
Guillaume Chelfice000fd2019-10-03 12:02:46 +02001534 pathname=${lines[@]:0:1}
The Android Open Source Project88b60792009-03-03 19:28:42 -08001535 fi
Ying Wang9cd17642012-12-13 10:52:07 -08001536 \cd $T/$pathname
The Android Open Source Project88b60792009-03-03 19:28:42 -08001537}
1538
Steven Moreland62054a42018-12-06 10:11:40 -08001539# Update module-info.json in out.
1540function refreshmod() {
1541 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
1542 echo "No ANDROID_PRODUCT_OUT. Try running 'lunch' first." >&2
1543 return 1
1544 fi
1545
1546 echo "Refreshing modules (building module-info.json). Log at $ANDROID_PRODUCT_OUT/module-info.json.build.log." >&2
1547
1548 # for the output of the next command
1549 mkdir -p $ANDROID_PRODUCT_OUT || return 1
1550
1551 # Note, can't use absolute path because of the way make works.
Alessandro Astonec8771be2020-05-10 11:27:57 +02001552 m $(get_build_var PRODUCT_OUT)/module-info.json \
Steven Moreland62054a42018-12-06 10:11:40 -08001553 > $ANDROID_PRODUCT_OUT/module-info.json.build.log 2>&1
1554}
1555
Cole Faust3e192382021-10-25 13:29:15 -07001556# Verifies that module-info.txt exists, returning nonzero if it doesn't.
Cole Faust24c36db2021-01-23 02:39:37 +00001557function verifymodinfo() {
Steven Moreland62054a42018-12-06 10:11:40 -08001558 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
Joe Onorato0bac4fe2021-04-07 08:51:28 -07001559 if [ "$QUIET_VERIFYMODINFO" != "true" ] ; then
1560 echo "No ANDROID_PRODUCT_OUT. Try running 'lunch' first." >&2
1561 fi
Steven Moreland62054a42018-12-06 10:11:40 -08001562 return 1
1563 fi
1564
1565 if [ ! -f "$ANDROID_PRODUCT_OUT/module-info.json" ]; then
Joe Onorato0bac4fe2021-04-07 08:51:28 -07001566 if [ "$QUIET_VERIFYMODINFO" != "true" ] ; then
Cole Faust3e192382021-10-25 13:29:15 -07001567 echo "Could not find module-info.json. Please run 'refreshmod' first." >&2
Joe Onorato0bac4fe2021-04-07 08:51:28 -07001568 fi
1569 return 1
Steven Moreland62054a42018-12-06 10:11:40 -08001570 fi
Cole Faust24c36db2021-01-23 02:39:37 +00001571}
1572
1573# List all modules for the current device, as cached in module-info.json. If any build change is
1574# made and it should be reflected in the output, you should run 'refreshmod' first.
1575function allmod() {
1576 verifymodinfo || return 1
Steven Moreland62054a42018-12-06 10:11:40 -08001577
Joe Onorato4acbe3b2021-04-29 15:31:42 -07001578 python3 -c "import json; print('\n'.join(sorted(json.load(open('$ANDROID_PRODUCT_OUT/module-info.json')).keys())))"
Steven Moreland62054a42018-12-06 10:11:40 -08001579}
1580
Joe Onorato2c1aa472021-02-25 16:42:39 -08001581# Get the path of a specific module in the android tree, as cached in module-info.json.
1582# If any build change is made, and it should be reflected in the output, you should run
1583# 'refreshmod' first. Note: This is the inverse of dirmods.
Rett Berg78d1c932019-01-24 14:34:23 -08001584function pathmod() {
Steven Moreland62054a42018-12-06 10:11:40 -08001585 if [[ $# -ne 1 ]]; then
Rett Berg78d1c932019-01-24 14:34:23 -08001586 echo "usage: pathmod <module>" >&2
Steven Moreland62054a42018-12-06 10:11:40 -08001587 return 1
1588 fi
1589
Cole Faust24c36db2021-01-23 02:39:37 +00001590 verifymodinfo || return 1
Steven Moreland62054a42018-12-06 10:11:40 -08001591
Joe Onorato4acbe3b2021-04-29 15:31:42 -07001592 local relpath=$(python3 -c "import json, os
Steven Moreland62054a42018-12-06 10:11:40 -08001593module = '$1'
1594module_info = json.load(open('$ANDROID_PRODUCT_OUT/module-info.json'))
1595if module not in module_info:
1596 exit(1)
LuK1337b6a78192020-01-12 03:12:17 +01001597print(module_info[module]['path'][0])" 2>/dev/null)
Steven Moreland62054a42018-12-06 10:11:40 -08001598
1599 if [ -z "$relpath" ]; then
1600 echo "Could not find module '$1' (try 'refreshmod' if there have been build changes?)." >&2
1601 return 1
1602 else
Rett Berg78d1c932019-01-24 14:34:23 -08001603 echo "$ANDROID_BUILD_TOP/$relpath"
Steven Moreland62054a42018-12-06 10:11:40 -08001604 fi
1605}
1606
Joe Onorato2c1aa472021-02-25 16:42:39 -08001607# Get the path of a specific module in the android tree, as cached in module-info.json.
1608# If any build change is made, and it should be reflected in the output, you should run
1609# 'refreshmod' first. Note: This is the inverse of pathmod.
1610function dirmods() {
1611 if [[ $# -ne 1 ]]; then
1612 echo "usage: dirmods <path>" >&2
1613 return 1
1614 fi
1615
1616 verifymodinfo || return 1
1617
Joe Onorato4acbe3b2021-04-29 15:31:42 -07001618 python3 -c "import json, os
Joe Onorato2c1aa472021-02-25 16:42:39 -08001619dir = '$1'
1620while dir.endswith('/'):
1621 dir = dir[:-1]
1622prefix = dir + '/'
1623module_info = json.load(open('$ANDROID_PRODUCT_OUT/module-info.json'))
1624results = set()
1625for m in module_info.values():
1626 for path in m.get(u'path', []):
1627 if path == dir or path.startswith(prefix):
1628 name = m.get(u'module_name')
1629 if name:
1630 results.add(name)
1631for name in sorted(results):
1632 print(name)
1633"
1634}
1635
1636
Rett Berg78d1c932019-01-24 14:34:23 -08001637# Go to a specific module in the android tree, as cached in module-info.json. If any build change
1638# is made, and it should be reflected in the output, you should run 'refreshmod' first.
1639function gomod() {
1640 if [[ $# -ne 1 ]]; then
1641 echo "usage: gomod <module>" >&2
1642 return 1
1643 fi
1644
1645 local path="$(pathmod $@)"
1646 if [ -z "$path" ]; then
1647 return 1
1648 fi
1649 cd $path
1650}
1651
Cole Faust24c36db2021-01-23 02:39:37 +00001652# Gets the list of a module's installed outputs, as cached in module-info.json.
1653# If any build change is made, and it should be reflected in the output, you should run 'refreshmod' first.
1654function outmod() {
1655 if [[ $# -ne 1 ]]; then
1656 echo "usage: outmod <module>" >&2
1657 return 1
1658 fi
1659
1660 verifymodinfo || return 1
1661
1662 local relpath
Joe Onorato4acbe3b2021-04-29 15:31:42 -07001663 relpath=$(python3 -c "import json, os
Cole Faust24c36db2021-01-23 02:39:37 +00001664module = '$1'
1665module_info = json.load(open('$ANDROID_PRODUCT_OUT/module-info.json'))
1666if module not in module_info:
1667 exit(1)
1668for output in module_info[module]['installed']:
1669 print(os.path.join('$ANDROID_BUILD_TOP', output))" 2>/dev/null)
1670
1671 if [ $? -ne 0 ]; then
1672 echo "Could not find module '$1' (try 'refreshmod' if there have been build changes?)" >&2
1673 return 1
1674 elif [ ! -z "$relpath" ]; then
1675 echo "$relpath"
1676 fi
1677}
1678
1679# adb install a module's apk, as cached in module-info.json. If any build change
1680# is made, and it should be reflected in the output, you should run 'refreshmod' first.
1681# Usage: installmod [adb install arguments] <module>
1682# For example: installmod -r Dialer -> adb install -r /path/to/Dialer.apk
1683function installmod() {
1684 if [[ $# -eq 0 ]]; then
1685 echo "usage: installmod [adb install arguments] <module>" >&2
Cole Faust3e192382021-10-25 13:29:15 -07001686 echo "" >&2
1687 echo "Only flags to be passed after the \"install\" in adb install are supported," >&2
1688 echo "with the exception of -s. If -s is passed it will be placed before the \"install\"." >&2
1689 echo "-s must be the first flag passed if it exists." >&2
Cole Faust24c36db2021-01-23 02:39:37 +00001690 return 1
1691 fi
1692
1693 local _path
1694 _path=$(outmod ${@:$#:1})
1695 if [ $? -ne 0 ]; then
1696 return 1
1697 fi
1698
1699 _path=$(echo "$_path" | grep -E \\.apk$ | head -n 1)
1700 if [ -z "$_path" ]; then
1701 echo "Module '$1' does not produce a file ending with .apk (try 'refreshmod' if there have been build changes?)" >&2
1702 return 1
1703 fi
Cole Faust3e192382021-10-25 13:29:15 -07001704 local serial_device=""
1705 if [[ "$1" == "-s" ]]; then
1706 if [[ $# -le 2 ]]; then
1707 echo "-s requires an argument" >&2
1708 return 1
1709 fi
1710 serial_device="-s $2"
1711 shift 2
1712 fi
Cole Faust24c36db2021-01-23 02:39:37 +00001713 local length=$(( $# - 1 ))
Cole Faust3e192382021-10-25 13:29:15 -07001714 echo adb $serial_device install ${@:1:$length} $_path
1715 adb $serial_device install ${@:1:$length} $_path
Cole Faust24c36db2021-01-23 02:39:37 +00001716}
1717
dimitry73b84812018-12-11 18:06:00 +01001718function _complete_android_module_names() {
Steven Moreland62054a42018-12-06 10:11:40 -08001719 local word=${COMP_WORDS[COMP_CWORD]}
Joe Onorato0bac4fe2021-04-07 08:51:28 -07001720 COMPREPLY=( $(QUIET_VERIFYMODINFO=true allmod | grep -E "^$word") )
Steven Moreland62054a42018-12-06 10:11:40 -08001721}
1722
Alex Rayf0d08eb2013-03-08 15:15:06 -08001723# Print colored exit condition
1724function pez {
Michael Wrighteb733842013-03-08 17:34:02 -08001725 "$@"
1726 local retval=$?
Matt Alexanderd9c56562020-05-21 10:49:17 +00001727 if [ $retval -ne 0 ]
1728 then
Jacky Cao89483b82015-05-15 22:12:53 +08001729 echo $'\E'"[0;31mFAILURE\e[00m"
Michael Wrighteb733842013-03-08 17:34:02 -08001730 else
Jacky Cao89483b82015-05-15 22:12:53 +08001731 echo $'\E'"[0;32mSUCCESS\e[00m"
Michael Wrighteb733842013-03-08 17:34:02 -08001732 fi
1733 return $retval
Alex Rayf0d08eb2013-03-08 15:15:06 -08001734}
1735
Matt Alexanderd9c56562020-05-21 10:49:17 +00001736function get_make_command()
1737{
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001738 # If we're in the top of an Android tree, use soong_ui.bash instead of make
1739 if [ -f build/soong/soong_ui.bash ]; then
Dan Willemsene9842242017-07-28 13:00:13 -07001740 # Always use the real make if -C is passed in
1741 for arg in "$@"; do
1742 if [[ $arg == -C* ]]; then
1743 echo command make
1744 return
1745 fi
1746 done
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001747 echo build/soong/soong_ui.bash --make-mode
1748 else
1749 echo command make
1750 fi
Ying Wanged21d4c2014-08-24 22:14:19 -07001751}
1752
Matt Alexanderd9c56562020-05-21 10:49:17 +00001753function _wrap_build()
1754{
Sasha Smundak9f27cc02019-01-31 13:25:31 -08001755 if [[ "${ANDROID_QUIET_BUILD:-}" == true ]]; then
1756 "$@"
1757 return $?
1758 fi
Ed Heylcc6be0a2014-06-18 14:55:58 -07001759 local start_time=$(date +"%s")
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001760 "$@"
Ed Heylcc6be0a2014-06-18 14:55:58 -07001761 local ret=$?
1762 local end_time=$(date +"%s")
1763 local tdiff=$(($end_time-$start_time))
1764 local hours=$(($tdiff / 3600 ))
1765 local mins=$((($tdiff % 3600) / 60))
1766 local secs=$(($tdiff % 60))
Greg Hackmannd95c7f72014-06-23 14:05:06 -07001767 local ncolors=$(tput colors 2>/dev/null)
1768 if [ -n "$ncolors" ] && [ $ncolors -ge 8 ]; then
Jacky Cao89483b82015-05-15 22:12:53 +08001769 color_failed=$'\E'"[0;31m"
1770 color_success=$'\E'"[0;32m"
Kousik Kumar09af2542021-08-19 16:13:32 -04001771 color_warning=$'\E'"[0;33m"
Jacky Cao89483b82015-05-15 22:12:53 +08001772 color_reset=$'\E'"[00m"
Greg Hackmannd95c7f72014-06-23 14:05:06 -07001773 else
1774 color_failed=""
1775 color_success=""
1776 color_reset=""
1777 fi
Kousik Kumar09af2542021-08-19 16:13:32 -04001778
1779 if [[ "x${USE_RBE}" == "x" && $mins -gt 15 && "${ANDROID_BUILD_ENVIRONMENT_CONFIG}" == "googler" ]]; then
1780 echo
1781 echo "${color_warning}Start using RBE (http://go/build-fast) to get faster builds!${color_reset}"
1782 fi
1783
Ed Heylcc6be0a2014-06-18 14:55:58 -07001784 echo
Matt Alexanderd9c56562020-05-21 10:49:17 +00001785 if [ $ret -eq 0 ] ; then
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001786 echo -n "${color_success}#### build completed successfully "
Ed Heylcc6be0a2014-06-18 14:55:58 -07001787 else
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001788 echo -n "${color_failed}#### failed to build some targets "
Ed Heylcc6be0a2014-06-18 14:55:58 -07001789 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +00001790 if [ $hours -gt 0 ] ; then
Ed Heylcc6be0a2014-06-18 14:55:58 -07001791 printf "(%02g:%02g:%02g (hh:mm:ss))" $hours $mins $secs
Matt Alexanderd9c56562020-05-21 10:49:17 +00001792 elif [ $mins -gt 0 ] ; then
Ed Heylcc6be0a2014-06-18 14:55:58 -07001793 printf "(%02g:%02g (mm:ss))" $mins $secs
Matt Alexanderd9c56562020-05-21 10:49:17 +00001794 elif [ $secs -gt 0 ] ; then
Ed Heylcc6be0a2014-06-18 14:55:58 -07001795 printf "(%s seconds)" $secs
1796 fi
Jacky Cao89483b82015-05-15 22:12:53 +08001797 echo " ####${color_reset}"
Ed Heylcc6be0a2014-06-18 14:55:58 -07001798 echo
1799 return $ret
1800}
1801
Patrice Arrudafa7204b2019-06-20 23:40:33 +00001802function _trigger_build()
1803(
1804 local -r bc="$1"; shift
1805 if T="$(gettop)"; then
1806 _wrap_build "$T/build/soong/soong_ui.bash" --build-mode --${bc} --dir="$(pwd)" "$@"
1807 else
Jingwen Chend728ee12021-05-18 06:02:53 +00001808 >&2 echo "Couldn't locate the top of the tree. Try setting TOP."
1809 return 1
Patrice Arrudafa7204b2019-06-20 23:40:33 +00001810 fi
1811)
1812
Jingwen Chen69f9ed12021-06-16 09:44:26 +00001813# Convenience entry point (like m) to use Bazel in AOSP.
Jingwen Chend728ee12021-05-18 06:02:53 +00001814function b()
1815(
1816 # Generate BUILD, bzl files into the synthetic Bazel workspace (out/soong/workspace).
Sam Delmerico9d67a902022-04-11 12:25:18 +00001817 _trigger_build "all-modules" bp2build USE_BAZEL_ANALYSIS= || return 1
Jingwen Chend728ee12021-05-18 06:02:53 +00001818 # Then, run Bazel using the synthetic workspace as the --package_path.
Sam Delmerico9d67a902022-04-11 12:25:18 +00001819 if [[ -z "$@" ]]; then
Jingwen Chen69f9ed12021-06-16 09:44:26 +00001820 # If there are no args, show help.
Jingwen Chenbfa114d2021-06-17 05:42:43 +00001821 bazel help
Jingwen Chen69f9ed12021-06-16 09:44:26 +00001822 else
1823 # Else, always run with the bp2build configuration, which sets Bazel's package path to the synthetic workspace.
Sam Delmerico9d67a902022-04-11 12:25:18 +00001824 bazel "$@" --config=bp2build
Jingwen Chen69f9ed12021-06-16 09:44:26 +00001825 fi
Jingwen Chend728ee12021-05-18 06:02:53 +00001826)
1827
Patrice Arrudafa7204b2019-06-20 23:40:33 +00001828function m()
1829(
1830 _trigger_build "all-modules" "$@"
1831)
1832
1833function mm()
1834(
1835 _trigger_build "modules-in-a-dir-no-deps" "$@"
1836)
1837
1838function mmm()
1839(
1840 _trigger_build "modules-in-dirs-no-deps" "$@"
1841)
1842
1843function mma()
1844(
1845 _trigger_build "modules-in-a-dir" "$@"
1846)
1847
1848function mmma()
1849(
1850 _trigger_build "modules-in-dirs" "$@"
1851)
1852
Matt Alexanderd9c56562020-05-21 10:49:17 +00001853function make()
1854{
Dan Willemsene9842242017-07-28 13:00:13 -07001855 _wrap_build $(get_make_command "$@") "$@"
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001856}
1857
Matt Alexanderd9c56562020-05-21 10:49:17 +00001858function provision()
1859{
David Zeuthen1b126ff2015-09-30 17:10:48 -04001860 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
1861 echo "Couldn't locate output files. Try running 'lunch' first." >&2
1862 return 1
1863 fi
1864 if [ ! -e "$ANDROID_PRODUCT_OUT/provision-device" ]; then
1865 echo "There is no provisioning script for the device." >&2
1866 return 1
1867 fi
1868
1869 # Check if user really wants to do this.
Matt Alexanderd9c56562020-05-21 10:49:17 +00001870 if [ "$1" = "--no-confirmation" ]; then
David Zeuthen1b126ff2015-09-30 17:10:48 -04001871 shift 1
1872 else
1873 echo "This action will reflash your device."
1874 echo ""
1875 echo "ALL DATA ON THE DEVICE WILL BE IRREVOCABLY ERASED."
1876 echo ""
Marie Janssen4afc2c02015-11-10 10:41:15 -08001877 echo -n "Are you sure you want to do this (yes/no)? "
1878 read
Matt Alexanderd9c56562020-05-21 10:49:17 +00001879 if [[ "${REPLY}" != "yes" ]] ; then
David Zeuthen1b126ff2015-09-30 17:10:48 -04001880 echo "Not taking any action. Exiting." >&2
1881 return 1
1882 fi
1883 fi
1884 "$ANDROID_PRODUCT_OUT/provision-device" "$@"
1885}
1886
Jim Tanga881a252018-06-19 16:34:41 +08001887# Zsh needs bashcompinit called to support bash-style completion.
Patrik Fimmldf248e62018-10-15 18:15:12 +02001888function enable_zsh_completion() {
1889 # Don't override user's options if bash-style completion is already enabled.
1890 if ! declare -f complete >/dev/null; then
1891 autoload -U compinit && compinit
1892 autoload -U bashcompinit && bashcompinit
1893 fi
Jim Tanga881a252018-06-19 16:34:41 +08001894}
1895
1896function validate_current_shell() {
1897 local current_sh="$(ps -o command -p $$)"
1898 case "$current_sh" in
Raphael Moll70a86b02011-06-20 16:03:14 -07001899 *bash*)
Jim Tanga881a252018-06-19 16:34:41 +08001900 function check_type() { type -t "$1"; }
Raphael Moll70a86b02011-06-20 16:03:14 -07001901 ;;
Jim Tanga881a252018-06-19 16:34:41 +08001902 *zsh*)
1903 function check_type() { type "$1"; }
Matt Alexanderd9c56562020-05-21 10:49:17 +00001904 enable_zsh_completion ;;
Raphael Moll70a86b02011-06-20 16:03:14 -07001905 *)
Jim Tanga881a252018-06-19 16:34:41 +08001906 echo -e "WARNING: Only bash and zsh are supported.\nUse of other shell would lead to erroneous results."
Raphael Moll70a86b02011-06-20 16:03:14 -07001907 ;;
1908 esac
Jim Tanga881a252018-06-19 16:34:41 +08001909}
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001910
1911# Execute the contents of any vendorsetup.sh files we can find.
Dan Willemsend855a722019-02-12 15:52:36 -08001912# Unless we find an allowed-vendorsetup_sh-files file, in which case we'll only
1913# load those.
1914#
1915# This allows loading only approved vendorsetup.sh files
Jim Tanga881a252018-06-19 16:34:41 +08001916function source_vendorsetup() {
Jim Tangc4dba1d2019-07-25 16:54:27 +08001917 unset VENDOR_PYTHONPATH
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001918 local T="$(gettop)"
Dan Willemsend855a722019-02-12 15:52:36 -08001919 allowed=
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001920 for f in $(cd "$T" && find -L device vendor product -maxdepth 4 -name 'allowed-vendorsetup_sh-files' 2>/dev/null | sort); do
Dan Willemsend855a722019-02-12 15:52:36 -08001921 if [ -n "$allowed" ]; then
1922 echo "More than one 'allowed_vendorsetup_sh-files' file found, not including any vendorsetup.sh files:"
1923 echo " $allowed"
1924 echo " $f"
1925 return
1926 fi
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001927 allowed="$T/$f"
Dan Willemsend855a722019-02-12 15:52:36 -08001928 done
1929
1930 allowed_files=
1931 [ -n "$allowed" ] && allowed_files=$(cat "$allowed")
Jim Tanga881a252018-06-19 16:34:41 +08001932 for dir in device vendor product; do
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001933 for f in $(cd "$T" && test -d $dir && \
Jim Tanga881a252018-06-19 16:34:41 +08001934 find -L $dir -maxdepth 4 -name 'vendorsetup.sh' 2>/dev/null | sort); do
Dan Willemsend855a722019-02-12 15:52:36 -08001935
1936 if [[ -z "$allowed" || "$allowed_files" =~ $f ]]; then
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001937 echo "including $f"; . "$T/$f"
Dan Willemsend855a722019-02-12 15:52:36 -08001938 else
1939 echo "ignoring $f, not in $allowed"
1940 fi
Jim Tanga881a252018-06-19 16:34:41 +08001941 done
1942 done
1943}
Kenny Root52aa81c2011-07-15 11:07:06 -07001944
Dan Albertbab814f2020-08-26 15:34:53 -07001945function showcommands() {
1946 local T=$(gettop)
1947 if [[ -z "$TARGET_PRODUCT" ]]; then
1948 >&2 echo "TARGET_PRODUCT not set. Run lunch."
1949 return
1950 fi
1951 case $(uname -s) in
1952 Darwin)
1953 PREBUILT_NAME=darwin-x86
1954 ;;
1955 Linux)
1956 PREBUILT_NAME=linux-x86
1957 ;;
1958 *)
1959 >&2 echo Unknown host $(uname -s)
1960 return
1961 ;;
1962 esac
1963 if [[ -z "$OUT_DIR" ]]; then
1964 if [[ -z "$OUT_DIR_COMMON_BASE" ]]; then
1965 OUT_DIR=out
1966 else
1967 OUT_DIR=${OUT_DIR_COMMON_BASE}/${PWD##*/}
1968 fi
1969 fi
1970 if [[ "$1" == "--regenerate" ]]; then
1971 shift 1
1972 NINJA_ARGS="-t commands $@" m
1973 else
1974 (cd $T && prebuilts/build-tools/$PREBUILT_NAME/bin/ninja \
1975 -f $OUT_DIR/combined-${TARGET_PRODUCT}.ninja \
1976 -t commands "$@")
1977 fi
1978}
1979
Jim Tanga881a252018-06-19 16:34:41 +08001980validate_current_shell
1981source_vendorsetup
Kenny Root52aa81c2011-07-15 11:07:06 -07001982addcompletions
Chirayu Desai798bc5e2013-03-19 17:50:37 +05301983
1984export ANDROID_BUILD_TOP=$(gettop)
Michael Bestasb744e742016-08-26 00:37:02 +03001985
1986. $ANDROID_BUILD_TOP/vendor/lineage/build/envsetup.sh
Alexander Martinz148bcce2022-04-07 18:02:53 +02001987. $ANDROID_BUILD_TOP/vendor/shiftos/build/envsetup.sh